#include "../include/includes.h"
#include <cstring> 
	
CChar CChar::first;
int zz = 0;

CChar::CChar() {
	memset(this, 0, sizeof(this));	
}


// removes the char from the charlist
void CChar::remove() {
	if(this->next) {
	this->prev->next = this->next;
	this->next->prev = this->prev;
	}
	else {
		this->prev->next = 0;
	}
}

// returns a pointer to a char matching a given charid or charname
CChar * CChar::getCChar(int charid, char charname[16],int targid) {
	int i = 0;
	CChar * tempChar;

	for(tempChar = CChar::first.next; tempChar != 0; tempChar = tempChar->next) {
		if((tempChar->charid == charid) || (tempChar->targid == targid) || (strcmp(tempChar->charname, charname ) == 0)) {
			return tempChar;
		}
	}
	return 0;
}

// add a command to all chars in list with the matching condition
void CChar::insertComm(int cond, CComm comm) {
	CChar * currChar;

	switch (cond) {
		
		case CHAR_INRANGE: 
			for(currChar = CChar::first.next; currChar != 0; currChar = currChar->next){
				if((currChar->loc.zone == this->loc.zone) && (currChar->charid != this->charid) && (currChar->charid != 0)){
					if(CUtil::distance(currChar->loc.p, this->loc.p) < 50) {
						currChar->addCommList(comm);
					}
				}
			}
			break;
		
		case CHAR_INRANGE_SELF: 
			for(currChar = CChar::first.next; currChar != 0; currChar = currChar->next){
				if((currChar->loc.zone == this->loc.zone) && (currChar->charid != 0) ){
					if(CUtil::distance(currChar->loc.p, this->loc.p) < 50) {
						currChar->addCommList(comm);
					}
				}
			}
			break;
			
		case CHAR_INZONE:
			for(currChar = CChar::first.next; currChar != 0; currChar = currChar->next){
				if((currChar->loc.zone == this->loc.zone) && (currChar->charid != this->charid) && (currChar->charid != 0) ){
					currChar->addCommList(comm);
				}
			}
			break;

		case CHAR_INZONE_SELF:
			for(currChar = CChar::first.next; currChar != 0; currChar = currChar->next){
				if((currChar->loc.zone == this->loc.zone) && (currChar->charid != 0)){
					currChar->addCommList(comm);
				}
			}
			break;

		case CHAR_ALL:
			for(currChar = CChar::first.next; currChar != 0; currChar = currChar->next){
				if (currChar->charid != 0){
					currChar->addCommList(comm);
				}
			}
			break;

		default:
			break;

	}

}
int i = 0;
// update a chars position and store it to the DB.
void CChar::updatePos(union PacketData pd){

	if(this->zoning)
		return;

	memcpy(&(this->loc.p.x), (char *)(pd.i+1), sizeof(int));
	memcpy(&(this->loc.p.y), (char *)(pd.i+2), sizeof(int));
	memcpy(&(this->loc.p.z), (char *)(pd.i+3), sizeof(int));

	memcpy(&(this->movCount), (char *)pd.c+0x12, 2);
	
	memcpy(&(this->loc.p.rotation), (char *)(pd.c+20), sizeof(char));

	memcpy(&(this->currTarg), (char *)pd.c+22, sizeof(unsigned short));
	

	if (i % 3 == 0) {
		if((CLuaManager::regionList[this->loc.zone].size() > 0)) {
			for(unsigned int a = 0; a < CLuaManager::regionList[this->loc.zone].size(); a++) {
				if (CUtil::withinDistance(CLuaManager::regionList[this->loc.zone].at(a).x1,CLuaManager::regionList[this->loc.zone].at(a).x2,CLuaManager::regionList[this->loc.zone].at(a).y1,CLuaManager::regionList[this->loc.zone].at(a).y2,CLuaManager::regionList[this->loc.zone].at(a).z1,CLuaManager::regionList[this->loc.zone].at(a).z2,this->loc.p)) {

					char file[255];
					lua_State* state = NULL;

					state = lua_open();
					CLuaManager::Initialize(state);
					CLuaManager::addVars(this,CLuaManager::regionList[this->loc.zone].at(a).ID,state);
					sprintf(file, "scripts/zones/%s/inregion.lua", CNpcHandler::getZoneName((unsigned short)this->loc.zone));
					if(!CLuaManager::scriptExists(file)) {
						lua_close( state );
					} 
					else {
						CLuaManager::runScript(file, state);
						lua_close( state );
					}
				}
			}
		}
	}
	else if(i % 32 == 0 ) { //approximately 9~10 seconds
		i=0;
		this->writeChar();
	}
	i++;

}

// send a tell
int CChar::sendTell(unsigned char * buf, union PacketData pd, unsigned short num){

 	char name[16];
	memcpy(name,pd.c+5,15);

	CComm comm;
	memcpy(comm.fromc, this->charname, 16);
	memset(pd.c+5+strlen(pd.c+5), 0, 15-strlen(pd.c+5));

	comm.pData = pd;
	comm.ident = 0x03;
	comm.lenght= pd.uc[1];

	CChar *t = new CChar();
	t = CChar::getCChar(0, name,0);

	CConsole::outTime("tell: %s: %s",name,pd.uc+20);
	memcpy(comm.message,pd.uc+20,strlen((char*)(pd.uc+20)));
	if(t) {
		comm.setComType(0xb6);
		t->addCommList(comm);
	}
	else {
		CConsole::outErr("Tell reciever not found");
		return this->sendErr(buf, 0x7d, num);
	}

	return 0;
}


// send std chat and intercept commands
int CChar::sendSay(unsigned char* data, union PacketData pd, unsigned short num){
	CComm comm;
	comm.pData = pd;
	if(pd.uc[6] == '@') {
		return this->atCommand(data, pd.c+6, num);
	}
	else {

		switch(pd.uc[4]){
			case 8:
			case 0:
				comm.setComType(0xb5);
				comm.lenght = pd.uc[1];
				memset(comm.message , 0, 255);
				memcpy(comm.message , pd.c+6, strlen(pd.c+6));
				memcpy(&comm.ident, pd.uc+4,1);
				memcpy(comm.fromc, this->charname, 16);
				this->insertComm(CHAR_INRANGE, comm);
				break;
			default:
				comm.setComType(0xb5);
				comm.lenght = pd.uc[1];
				memset(comm.message , 0, 255);
				memcpy(comm.message , pd.c+6, strlen(pd.c+6));
				memcpy(&comm.ident, pd.uc+4, 1);
				memcpy(comm.fromc, this->charname, 16);
				this->insertComm(CHAR_INZONE, comm);
				break;
		}
	}
	return 0;
}

// sets the chars position
int CChar::setPosition(unsigned char * data, float x, float y, float z, unsigned short num){
	memset(data, 0, 28);
	data[0] = 0x5B;
	data[1] = 0x0E;
	memcpy(data+2, &num, sizeof(num));
	memcpy(data+4, &x, sizeof(x));
	memcpy(data+8, &y, sizeof(y));
	memcpy(data+12, &z, sizeof(z));

	memcpy(data+16, &(this->charid), sizeof(this->charid));
	memcpy(data+20, &(this->targid), sizeof(this->targid));

	return 28;
}

// perform forced zoning
int CChar::zoneChar(unsigned char to){
	char query[8192];
	unsigned long count;
	MYSQL_RES * res;
	MYSQL_ROW row;

	sprintf(query,"SELECT  tox, toy, toz, rotation FROM zoneline WHERE tozone = 0x%x ",to);
	count = strlen(query);
	strcpy(query+count, " LIMIT 1");
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	this->loc.prevzone = this->loc.zone;
	this->loc.zone = to;

	if(!(res = mysql_store_result(CDb::getConn()))){
		CConsole::outErr("Error looking up zone");
		
	}

	if(!mysql_num_rows(res)){
		mysql_free_result(res);
		CConsole::outErr("Error looking up zone");
	
	} else {
		row = mysql_fetch_row(res);
		memcpy(&(this->loc.p.x), row[0], sizeof(float));
		CConsole::outTime("%d %d %d", row[0][0],row[1][0],row[2][0]);
		memcpy(&(this->loc.p.y), row[1], sizeof(float));
		memcpy(&(this->loc.p.z), row[2], sizeof(float));
		memcpy(&(this->loc.p.rotation), row[3], sizeof(unsigned short));	
		
		mysql_free_result(res);
	}

	sprintf(query, "UPDATE chars SET udate=CURRENT_TIMESTAMP, pos_x = %f, pos_y = %f, pos_z = %f, pos_rot = %i, pos_zone = %i, pos_prevzone = %i WHERE charid = %i",
		this->loc.p.x,this->loc.p.y,this->loc.p.z,this->loc.p.rotation,this->loc.zone,this->loc.prevzone,this->charid);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);


	CComm comm1;
	comm1.setComType(0x101);
	comm1.ptr = (LPVOID *)this;
	this->insertComm(CHAR_INZONE, comm1);

	CComm *comm = new CComm();
	comm->setComType(0x5E0C);
	comm->flags = 0x01000000;

	this->addCommList(*comm);
	CConsole::outTime("Zoning %s\n", this->charname);
	return 0;
}

// request to zone
int CChar::chip(unsigned char *pd, unsigned short num){

	unsigned short port = 54230;
	memset(pd, 0, 28);
	pd[0] = 0x0B;
	pd[1] = 0x0E;
	memcpy(pd+2, &num, sizeof(num));

	pd[4] = 2;
	CConsole::outTime("ServIP %x", this->servip);
	memcpy(pd+8, &(this->servip), sizeof(this->servip));
	memcpy(pd+0x0C, &port, sizeof(unsigned short));//pd->us[6] = 54230;

	return 28;
}

// prepare char
int CChar::changeZone(){
	this->locked = true;
	char query[8192];
	unsigned long count, i;
	unsigned char hash[16];

	this->enc.key[4] += 2;

	md5((unsigned char*)(this->enc.key), hash, 20);

	for(i = 0; i < 16; i++)
		if(hash[i] == 0)
			break;
	memset(hash+i, 0, 16-i);
	memcpy(this->enc.hash, hash, 16);

	CBlowfish::init((char *)this->enc.hash, 16, this->enc.P, this->enc.S[0]);

	strcpy(query, "UPDATE chars SET sessionkey='");
	count = strlen(query);
	count += mysql_real_escape_string(CDb::getConn(), query+count, (char *)(this->enc.key), 20);
	strcpy(query+count, "' WHERE ip='");
	count += strlen(query+count);
	count += mysql_real_escape_string(CDb::getConn(), query+count, (char *)&(this->ip), sizeof(unsigned long));
	query[count++] = '\'';
	mysql_real_query(CDb::getConn(), query, count);

	this->locked = false;
	return 0;
}

// actually zone
int CChar::zoner(unsigned char * data, unsigned short num){
	unsigned int  size, i, status;
	long count;
	unsigned long long time1;
	short csid = 0;
	size = 328;
	memset(data, 0, size);
	this->spawnIDList.clear();
	char file[255];
	lua_State* state = NULL;

	state = lua_open();
	CLuaManager::Initialize(state);
	CLuaManager::addVars(this, (int)this->loc.prevzone, state);
		
	sprintf(file, "scripts/zones/%s/onZoneIn.lua", CNpcHandler::getZoneName(this->loc.zone));
	if(CLuaManager::scriptExists(file)) {
		CLuaManager::runScript(file, state);
		lua_gettop(state);
		csid = (short)lua_tonumber(state,-1);
	}
	lua_close( state );

	//Command Heads
	data[0] = 0x4F; data[1] = 0x04; memcpy(data+2, &num, sizeof(num));
	data[8] = 0x51; data[9] = 0x0C; memcpy(data+10, &num, sizeof(num));
	data[32] = 0x0A; data[33] = 0x82; memcpy(data+34, &num, sizeof(num));
	data[0x124] = 0x08; data[0x125] = 0x12; memcpy(data+0x126, &num, sizeof(num));
	
	count = ((long)time(NULL) - 1009810800);
	time1 = time(NULL);
	memcpy(data+0x59, &time1, 4);
	memcpy(data+0x5c, &count, sizeof(count));

	if(csid != 0) {
		data[32+0x62] = this->loc.zone;
		memcpy(data+32+0x64,&csid,2);
		data[32+0x66] = 0x03;
		data[32+0x68] = 0x01;
	}


	if(this->loc.prevzone == 0x00) {
		data[32+0x62] = this->loc.zone;
	
		switch(this->st.n.home) {
			case 0x02:
				data[32+0x64] = 0x31;
				data[32+0x65] = 0x01;
				data[32+0x66] = 0x93;
				data[32+0x6a] = 0x01;

				break;
			case 0x01:
				data[32+0x64] = 0x01;
				data[32+0x66] = 0x83;
				data[32+0x68] = 0x01;

				break;
			case 0x00:
				data[32+0x64] = 0x17;
				data[32+0x65] = 0x02;
				data[32+0x66] = 0x83;
				data[32+0x68] = 0x01;

				break;
		}
	}


	memcpy(data+12,   &(this->l), sizeof(this->l));
	memcpy(data+0x64, &(this->l), sizeof(this->l));
	memcpy(data+0x24, &(this->charid), sizeof(int));
	memcpy(data+0x28, &(this->targid), sizeof(unsigned int));

	data[0x3f] = this->h.animation;


	status = ((this->h.status & 0xff000000) >> 5) + ((this->h.status & 0x000000ff) << 7);
	memcpy(data+0x40, &(status), sizeof(int));
	memcpy(data+0xA4, this->charname, 16);
	memcpy(data+0xD8, &(this->j), sizeof(this->j));
	memcpy(data+0xEC, &(this->st.str), 14);
	memcpy(data+0x108, &(this->st.mHP), 8);
	this->h.status = status;


	// 2008/09/04 ړxݒ Mod-Start
	//data[0x3c] = 0x28;		//speed

	// ړxŒlݒlgpɕύX
	data[0x3c] = this->charspd;
	// 2008/09/04 ړxݒ Mod-End
	data[0x3d] = 0x28;	
	data[0x3e] = 0x64;


	if((this->loc.zone > 0xfc) || ((this->loc.zone > 0xd5) & (this->loc.zone < 0xdb)) ){
		data[0xA0] = 1;													// mog house flag
		//this->loc.prevzone = this->loc.;
		memcpy(data+0x50, &(this->loc.prevzone), sizeof(char));			//previous zone
		memcpy(data+0x62, &(this->loc.prevzone), sizeof(char));			//previous zone
		memcpy(data+0xCA, &(this->loc.zone), sizeof(char));				//to zone

	} else {
		data[0xA0] = 2;			
		memcpy(data+0x50, &(this->loc.zone), sizeof(char));				//to zone
		memcpy(data+0x62, &(this->loc.zone), sizeof(char));				//to zone
	}

	MYSQL_RES * res;
	MYSQL_ROW row;
	char query[1024];
	strcpy(query, "SELECT sng1, sng2, battlesolo, battlemulti FROM zone_settings WHERE Zoneid = '");
	count = strlen(query);
	count += mysql_real_escape_string(CDb::getConn(), query+count, (char *)&(this->loc.zone), 1);
	strcpy(query+count, "' LIMIT 1");
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);
	res = mysql_store_result(CDb::getConn());
	if(row = mysql_fetch_row(res)) {
		data[0x76] = (unsigned char)row[0][0];	// background music
		data[0x78] = (unsigned char)row[0][2];	// background 2
		data[0x7a] = (unsigned char)row[0][4];	// solo battle music
		data[0x7c] = (unsigned char)row[0][6];	// party battle music
	}
	mysql_free_result(res);

	
	memcpy(data+0x2B, &(this->loc.p.rotation), 1);						//rotation
	memcpy(data+0x2c, (char *)&(this->loc.p.x), sizeof(float));			//x
	memcpy(data+0x30, (char *)&(this->loc.p.y), sizeof(float));			//y
	memcpy(data+0x34, (char *)&(this->loc.p.z), sizeof(float));			//z
	
	memcpy(data+0xB8, &(this->ip), 4);

	memset(data+size, 0, 128);
	for(i=0; i<16; i++) {
		data[size] = 0x50;
		data[size+1] = 0x04;
		memcpy(data+size+2, &num, sizeof(num));
		data[size+4] = this->e.SlotID[i];
		data[size+5] = i;
		size += 8;
	}

	
	this->zoning = false;
	return size;
}

// zone using a zoneline
int CChar::zoneLine(union PacketData pd){
	MYSQL_RES * res;
	MYSQL_ROW row;
	char query[8192];
	int count;

	CComm comm;
	comm.setComType(0x101);
	comm.ptr = (LPVOID *)this;
	this->insertComm(CHAR_INZONE, comm);

	strcpy(query, "SELECT tozone, tox, toy, toz, rotation FROM zoneline WHERE fromline = '");
	count = strlen(query);
	count += mysql_real_escape_string(CDb::getObj()->getConn(), query+count, pd.c+4, 4);
	strcpy(query+count, "' LIMIT 1");
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);
	if(!(res = mysql_store_result(CDb::getConn()))){
		CConsole::outErr("Error looking up zone");
		goto frloop;
	}
	if(!mysql_num_rows(res)){
		mysql_free_result(res);
		if(((this->loc.zone > 0xd5) & (this->loc.zone < 0xdb)) || (this->loc.zone > 0xfc)) {
			this->loc.zone = this->loc.prevzone;
			memset(&(this->loc.p.x), 0, sizeof(float)*3);
		} else {
			CConsole::outErr("Zone line not found, using default");
frloop:		this->loc.zone = 0xf5;
			this->loc.prevzone = this->loc.zone;
			memset(&(this->loc.p.x), 0, sizeof(float)*3);
		}
	} else {
		row = mysql_fetch_row(res);
		this->loc.prevzone = this->loc.zone;
		this->loc.zone = row[0][0];
		memcpy(&(this->loc.p.x), row[1], sizeof(float));
		memcpy(&(this->loc.p.y), row[2], sizeof(float));
		memcpy(&(this->loc.p.z), row[3], sizeof(float));
		mysql_free_result(res);
	}

	sprintf(query, "UPDATE chars SET udate=CURRENT_TIMESTAMP, pos_x = %f, pos_y = %f, pos_z = %f, pos_rot = %i, pos_zone = %i, pos_prevzone = %i WHERE charid = %i",
		this->loc.p.x,this->loc.p.y,this->loc.p.z,this->loc.p.rotation,this->loc.zone,this->loc.prevzone,this->charid);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	CConsole::outTime("Zoning %s\n", this->charname);

	return 0;
}

// process @commands
int CChar::atCommand(unsigned char * buf, char * data, unsigned short num){
	int dummy=0, dummy1=0, dummy2=0;
	if(!memcmp(data, "@zone ", 6)){
		sscanf(data, "@zone %hx", (&dummy));
		if( dummy > 0xff) {
			dummy = 0xff;
		}	
		this->zoning = true;
		this->zoneChar(dummy);
	}
	else if(!memcmp(data, "@hp ", 4)){
		sscanf(data, "@hp %hx", &(dummy));
		if((unsigned int)dummy > this->st.mHP) {
			dummy = this->st.mHP;
		}
		this->h.hp = dummy;
		this->h.hpp = (unsigned char)((float)dummy / (float)this->st.mHP) * 100;

		if( this->h.hp == 0) {
			this->h.animation = 0x03;
			return updateChar(buf,num);
		}
	}
	else if(!memcmp(data, "@inject ", 8))
		return CPacket::loadPacket(data+8, buf, num);
	else if(!memcmp(data, "@easteregg", 10)){
		this->addItem(0x40EE, 0, 1);
		return this->loadInv(buf,  num);
	} 
	else if(!memcmp(data, "@additem ", 9)){
		sscanf(data, "@additem %x", &dummy);
		this->addItem(dummy, 0, 1);
		return this->loadInv(buf, num);
	}
	else if(!memcmp(data, "@ship ", 6)){
		sscanf(data, "@ship %x", &dummy);
		return CPacket::loadPacket2("sanship.dat", buf, num,dummy);
	}
	else if(!memcmp(data, "@cs ", 4)){
		sscanf(data, "@cs %x", &dummy);
		CComm comm;
		CPacket::genCSPacket(comm.message,this->charid,this->targid,this->loc.zone,dummy);
		comm.charid = comm.message[1]*2;
		comm.setComType(0x1234);
		this->addCommList(comm);
	}
	else if(!memcmp(data,"@animation %x", 11)){
		sscanf(data, "@animation %x", &dummy);
		this->h.animation = (unsigned char)dummy;
        return updateChar(buf,num);
	}
	else if(!memcmp(data,"@zoneR %x", 7)){
		sscanf(data, "@zoneR %x", &dummy);
		CNpcHandler::loadZoneList(dummy);
	}
	
	else if(!memcmp(data,"@mobani %x", 8)){
		sscanf(data, "@mobani %x", &dummy);

		CMob * mob;
		mob = CNpcHandler::getMobByTarg(this->currTarg, this->loc.zone);

		if(!mob) {
			return 0;
		}
		
		CConsole::outTime("NAME %s ID: %X",mob->name, mob->id);

		mob->ownerId = this->charid;
		mob->incombat = true;
		mob->update = true;
		mob->animation = dummy;
		mob->victim = this;
		
		return 0;
	}

	else if(!memcmp(data,"@mobstat %x", 9)){
		sscanf(data, "@mobstat %x", &dummy);

		CNpc * npc;
		npc = CNpcHandler::getNpcByTarg(this->currTarg, this->loc.zone);

		if(!npc) {
			return 0;
		}

		CConsole::outTime("NAME %s ID: %X",npc->name,npc->id);
		CConsole::outTime("stat  %X",npc->status);


		for(unsigned int j = 0; j < CNpcHandler::npcZoneList[this->loc.zone].size(); j++) {
			if(CNpcHandler::npcZoneList[this->loc.zone].at(j).id == npc->id) {
				memcpy(&CNpcHandler::npcZoneList[this->loc.zone].at(j).status, &dummy, 1);
				break;
			}
		}
		int size = 0;
		buf[size] = 0x0E;
		buf[size+1] = (unsigned char)((0x33+strlen((const char*)npc->name)+sizeof(int))/4)*2;
 		memcpy(buf+size+0x30, &(npc->look), 4);
		memcpy(buf+size+0x34, npc->name, strlen((const char*)npc->name));
		
		CConsole::outTime("NAME %s ID: %X",npc->name,npc->id);
 		memcpy(buf+size+2, &num, sizeof(short));
		 	memcpy(buf+size+4, &npc->id, 4);
	 		memcpy(buf+size+8, &npc->targid, 2);
			buf[size+0x1f] = npc->animation;
			buf[size+10] = npc->type;
 			buf[size+11] = (unsigned char)npc->p.rotation;
			buf[size+0x1c] = 0x28;		
			buf[size+0x1d] = 0x28;
 			buf[size+0x1E] = 0x64;
 			buf[size+0x27] = 0x20;
 			
			memcpy(buf+size+12, &npc->p.x, 4);
 			memcpy(buf+size+16, &npc->p.y, 4);
			memcpy(buf+size+20, &npc->p.z, 4);
 			memcpy(buf+size+24, &npc->flag, 4);
			
			memcpy(buf+size+0x2c, &npc->ownerId, 4);
			memcpy(buf+size+0x20, &dummy, 4);
 			size += buf[size+1]*2;
		//dummy;
         return size;
	}
    else if(!memcmp(data, "@npc", 4)){
		float smallest = -1.0;
		float dist = 0.0;
		CNpc npc;
		if (CNpcHandler::npcZoneList[this->loc.zone].size() > 0){
			for(unsigned int i = 0; i < (CNpcHandler::npcZoneList[this->loc.zone].size()); i++){
				npc = CNpcHandler::npcZoneList[this->loc.zone].at(i);
				dist = CUtil::distance(this->loc.p, npc.p);
				if (dist < smallest || smallest == -1.0){
					dummy = i;
					smallest = dist;
				}
			}
			npc = CNpcHandler::npcZoneList[this->loc.zone].at(dummy);
			CConsole::outTime("The closest npc is: %x %x",npc.id,npc.targid);
		}
		else {
			CConsole::outTime("No NPCs on this zone!");
		}
	}

    else if(!memcmp(data, "@gm", 3)){
		this->h.status ^= FLAG_GM;
		return updateChar(buf, num);
	} 
	else if(!memcmp(data, "@status ", 8)){
		sscanf(data, "@status %d ", &dummy);
		this->h.status = dummy;
		return updateChar(buf, num);
	} 
    else if(!memcmp(data, "@where", 6)){
		char msg[255];
		memset(msg,0,255);
		sprintf(msg,"X:%f, Y:%f, Z:%f",this->loc.p.x,this->loc.p.y,this->loc.p.z);
	    CPacket::sendServerTell("PXI",  this->charname, msg);
		CConsole::outTime("%s  X:%f  Y:%f  Z:%f  ZoneID: %x", this->charname, this->loc.p.x, this->loc.p.y, this->loc.p.z, this->loc.zone);
	}
	else if(!memcmp(data, "@pos ", 5)){
		sscanf(data, "@pos %d %d %d", &dummy, &dummy1, &dummy2);
		return this->setPosition(buf, (float)dummy, (float)dummy1, (float)dummy2, num);
	} 
	else if(!memcmp(data, "@posr ", 6)){
		sscanf(data, "@posr %d %d %d", &dummy, &dummy1, &dummy2);
		return this->setPosition(buf, (this->loc.p.x+(float)dummy),  (this->loc.p.y+(float)dummy1),  (this->loc.p.z+(float)dummy2), num);
	} 
	else if(!memcmp(data, "@changejob ", 11)){
		sscanf(data, "@changejob %x %d", &dummy, &dummy2);
		return this->cmjob(buf, (unsigned char)dummy, (unsigned char)dummy2,  num);
	}
	// 2008/09/04 UԊuݒ Add-Start
	else if(!memcmp(data, "@delay ", 7)) {
		// @delay [10il]ōUԊuw
		sscanf(data, "@delay %d", &dummy);
		if(dummy > 999) {
			// UԊul999Ƃ
			dummy = 999;
		}
		// wlUԊuɐݒ
		this->atkdelay = dummy;
	}
	// 2008/09/04 UԊuݒ Add-End
	// 2008/09/04 ړxݒ Add-Start
	else if(!memcmp(data, "@speed ", 7)) {
		// @speed [16il]ňړxw
		sscanf(data, "@speed %x", &dummy);
		if(dummy > 0xFF) {
			// ړxl0xFFƂ
			dummy = 0xFF;
		}
		// wlړxɐݒ
		this->charspd = (unsigned char)dummy;
		// LN^[XV
		return updateChar(buf, num);
	}
	// 2008/09/04 ړxݒ Add-End
	else if(!memcmp(data, "@debug", 6))
		this->debugMsg("charid %x targid %x", this->charid, this->targid);
	return 0;
}

int CChar::logout(unsigned char * data, unsigned short num){
	memset(data, 0, 28);
	data[0] = 0xB;
	data[1] = 0xE;
	memcpy(data+2, &num, sizeof(num));
	data[4] = 1;
	CComm comm;
	comm.setComType(0x101);
	comm.ptr = (LPVOID *)this;
	this->insertComm(CHAR_INZONE, comm);
	this->remove();
	return 28;
}

int CChar::allowLogout(unsigned char * data, unsigned short num){

	memset(data, 0, 0x50);
	data[0] = 0x4b;
	data[1] = 0x0a;
	memcpy(data+2, &num, sizeof(num));
	data[0x14] = 0x4c;
	data[0x15] = 0x1e;
	
	CComm *comm = new CComm();
	comm->setComType(0x0b);
	this->addCommList(*comm);


	return 80;
}

int CChar::updateKeyItems(unsigned char * data, unsigned short num) {
		
	int size = 0;
	memset(data,0,0x44*2);
	data[0] = 0x55;
	data[1] = 0x44;
	memcpy(data+2, &num, sizeof(num));
	memcpy(data+4, this->k.keyList,0x40);
	memcpy(data+4+0x40, this->k.seenList,0x40);

	size+=0x44*2;

	return size;
}



int CChar::release(unsigned short * data, unsigned short num){
	memset(data, 0, 8);
	data[0] = 0x0452;
	data[1] = num;

	return 8;
}

int CChar::equip(unsigned char * data, char * in, unsigned short num){
	MYSQL_RES * res;
	MYSQL_ROW row;
	char query[8192];
	unsigned int  size = 0, i, id;

	unsigned long count;

	if((in[5] == 0x0B) && (in[4] != 0)){
		if(this->e.SlotID[0x0C] == in[4])
			return 0;
	} else if((in[5] == 0x0C) && (in[4] != 0)){
		if(this->e.SlotID[0x0B] == in[4])
			return 0;
	} else if((in[5] == 0x0D) && (in[4] != 0)){
		if(this->e.SlotID[0x0E] == in[4])
			return 0;
	} else if((in[5] == 0x0E) && (in[4] != 0)){
		if(this->e.SlotID[0x0D] == in[4])
			return 0;
	}
	if(in[4]){
		sprintf(query, "SELECT item FROM char_inventory WHERE id = %i AND charid = %i", in[4],this->charid);
		count = strlen(query);
		mysql_real_query(CDb::getConn(), query, count);

		if(!(res = mysql_store_result(CDb::getConn()))){
			CConsole::outErr("Error looking up equipment");
			return 0;
		}
		if(!mysql_num_rows(res)){
			mysql_free_result(res);
			CConsole::outErr("You don't own that item");
			return 0;
		}

		row = mysql_fetch_row(res);
		i = atoi(row[0]);
		mysql_free_result(res);

		count = sprintf(query, "(SELECT `mID`,`str`,`dex`,`vit`,`agi`,`int`,`mnd`,`chr`,`hp`,`mp` FROM stats_armor WHERE itemID = %i) ",i);
		count = strlen(query);
		sprintf(query+count, " UNION (SELECT `mID`,`str`,`dex`,`vit`,`agi`,`int`,`mnd`,`chr`,`hp`,`mp` FROM stats_weapons WHERE itemID = %i) ",i);
		count = strlen(query);
		mysql_real_query(CDb::getConn(), query, count);
	
		if(!(res = mysql_store_result(CDb::getConn()))){
			CConsole::outErr("Error looking up modelid");
			id=8;
			goto send;
		}
		if(mysql_num_rows(res)){
			row = mysql_fetch_row(res);
			id=atoi(row[0]);
			this->st.pstr += atoi(row[1]);
			this->st.pdex += atoi(row[2]);
			this->st.pvit += atoi(row[3]);
			this->st.pagl += atoi(row[4]);
			this->st.pint += atoi(row[5]);
			this->st.pmnd += atoi(row[6]);
			this->st.pchr += atoi(row[7]);
			this->st.mHP  += atoi(row[8]);
			this->st.mMP  += atoi(row[9]);
			this->st.atk = 8 + ((this->st.str + this->st.pstr) /2);
		} else
			id=8;
		mysql_free_result(res);
	} else {
		i = 0;
		id = 0;
	}
send:

	memcpy(data, in, 8);
	memcpy(data+2, &num, sizeof(num));
	size = 8;
	
	memset(data+size, 0, 24);
	data[size] = 0x51;
	data[size+1] = 0x0C;
	memcpy(data+size+2, &num, sizeof(num));
	memcpy(data+size+4, (char *)&(this->l), sizeof(this->l));
	
	switch (in[5]) {
		case 0x00: 
			this->l.main =id- 0x6000;
			memcpy(data+size+16, &id, 2);
			this->calculateAttackSpeed();
			break;
		case 0x01:
			this->l.sub =id- 0x7000;
			memcpy(data+size+18, &id, 2);
			break;
		case 0x02:
			this->l.range =id- 0x8000;
			memcpy(data+size+20, &id, 2);
			break;
		case 0x04:
			this->l.head =id - 0x1000;
			memcpy(data+size+6, &id, 2); 
			break;
		case 0x05:
			this->l.body = id - 0x2000;
			memcpy(data+size+8, &id, 2); 
			break;
		case 0x06: 
			this->l.hands = id - 0x3000;
			memcpy(data+size+10, &id, 2);
			break;
		case 0x07:
			this->l.legs = id - 0x4000;
			memcpy(data+size+12, &id, 2);
			break;
		case 0x08:
			this->l.feet = id - 0x5000;
			memcpy(data+size+14, &id, 2);
			break;
	}

	if(id != this->e.ItemID[(unsigned int)in[5]]) {

		count = sprintf(query, "(SELECT `mID`,`str`,`dex`,`vit`,`agi`,`int`,`mnd`,`chr`,`hp`,`mp` FROM stats_armor WHERE itemID = %i) ",this->e.ItemID[(unsigned int)in[5]]);
		count = strlen(query);
		sprintf(query+count, " UNION (SELECT `mID`,`str`,`dex`,`vit`,`agi`,`int`,`mnd`,`chr`,`hp`,`mp` FROM stats_weapons WHERE itemID = %i) ",this->e.ItemID[(unsigned int)in[5]]);
		count = strlen(query);
		mysql_real_query(CDb::getConn(), query, count);
	
		if(!(res = mysql_store_result(CDb::getConn()))){
			CConsole::outErr("Error looking up modelid");
		}
		if(mysql_num_rows(res)){
			row = mysql_fetch_row(res);
			this->st.pstr -= atoi(row[1]);
			this->st.pdex -= atoi(row[2]);
			this->st.pvit -= atoi(row[3]);
			this->st.pagl -= atoi(row[4]);
			this->st.pint -= atoi(row[5]);
			this->st.pmnd -= atoi(row[6]);
			this->st.pchr -= atoi(row[7]);
			this->st.mHP -= atoi(row[8]);
			this->st.mMP -= atoi(row[9]);
			this->st.atk = 8 + ((this->st.str + this->st.pstr) /2);
		}
		mysql_free_result(res);
	}
	memcpy(&(this->e.SlotID[(unsigned int)in[5]]), in+4, 1);
	memcpy(&(this->e.ItemID[(unsigned int)in[5]]), &i, sizeof(short));
	

	sprintf(query, "UPDATE char_look SET head = %i, body = %i, hands = %i, legs = %i, feet = %i, main = %i, sub = %i, range = %i WHERE charid = %i", 
		this->l.head,this->l.body,this->l.hands,this->l.legs,this->l.feet,this->l.main,this->l.sub,this->l.range,this->charid);

	count = strlen(query);
	mysql_real_query(CDb::getConn(),query , count);


	size += 24;

	return size;
}

int CChar::loadInv(unsigned char * data, unsigned short num){
	MYSQL_RES * res;
	MYSQL_ROW row;
	char query[8192];
	unsigned long count, * lengths;
	unsigned short item = 0;
	int size = 0;

	sprintf(query, "SELECT item, quantity, location, id FROM char_inventory WHERE charid = %i",this->charid);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	if(!(res = mysql_store_result(CDb::getConn()))){
		CConsole::outErr("Error looking up characters inventory");
		return 0;

	}
	
	// send gil info 
	size = 0x2c;
	memset(data, 0, 0x2C);
	data[0] = 0x20;
	data[1] = 0x16;
	memcpy(data+2, &num, sizeof(num));
	memcpy(data+4, &(this->inv.gil), 4);
	data[0x0c] = 0xFF;
	data[0x0d] = 0xFF;

	if(!mysql_num_rows(res)){
		mysql_free_result(res);
		
		//return 0;
	}
	else {
		while((row = mysql_fetch_row(res))){
			lengths = mysql_fetch_lengths(res);
			memset(data+size, 0, 0x2C);
			data[size] = 0x20;
			data[size+1] = 0x16;
			memcpy(data+size+2, &num, sizeof(num));
			data[size+4] = atoi(row[1]);
			item = atoi(row[0]);
			memcpy(data+size+12, &item, 2);
			data[size+14] = atoi(row[2]);
			data[size+15] = atoi(row[3]);
			size += 0x2C;
		}	
		mysql_free_result(res);
	}

	memset(data+size, 0, 8);
	data[size] = 0x1d;
	data[size+1] = 4;
	memcpy(data+size+2, &num, sizeof(num));
	data[size+4] = 1;
	size += 8;

	return size;
}

int CChar::addItem(unsigned short item, unsigned char location, unsigned char quantity){
	MYSQL_RES * res;
	MYSQL_ROW row;
	char query[8192], id;
	unsigned long count;

	sprintf(query, "SELECT id FROM char_inventory WHERE charid = %i AND location = %i ORDER BY id ASC", this->charid, location);
	count = strlen(query);

	mysql_real_query(CDb::getConn(), query, count);
	id = 1;
	if((res = mysql_store_result(CDb::getConn()))){
		if(mysql_num_rows(res)){
			while((row = mysql_fetch_row(res))){
				if ((unsigned int)atoi(row[0]) != id){
					break;
				}
				id++;
			}
		}
		mysql_free_result(res);
	}
	if (id >= 80) {
	    CPacket::sendServerTell("PXI",  this->charname, "You cannot have more than 80 items, drop some stuff!!");
		return 0;
	}
	sprintf(query, "INSERT INTO char_inventory (charid, id, location, quantity, item) VALUES (%i,%i,%i,%i,%i)",
		this->charid, id, location, quantity, item);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	return 0;
}

int CChar::health(unsigned char * data, unsigned short num){

	// temporary
	this->h.tp = 0;

	memset(data, 0, 28);
	data[0] = 0xDF;
	data[1] = 0x0E;
	memcpy(data+2, &num, sizeof(num));
	memcpy(data+4, &(this->charid), 4);
	memcpy(data+8, &(this->h.hp), 2);
	memcpy(data+12, &(this->h.mp), 2);
	memcpy(data+16, &(this->h.mp), 2);

	memcpy(data+0x14, &(this->targid), 2);
	data[0x16] = (unsigned char)((float)this->h.hp / (float)this->st.mHP * 100);
	data[0x17] = (unsigned char)((float)this->h.mp / (float)this->st.mMP * 100);

	return 28;
}

int CChar::cmjob(unsigned char * data, unsigned char job, unsigned char level, unsigned short num){
	char query[8192];
	int count;

	if(level > 75)
		level = 75;
	if(job > 0x14)
		job = 0x14;

	this->st.mJob = job;
	this->st.mLvl = level;

	this->st.calcStats(this->l);

	this->h.hp = this->st.mHP;
	this->h.mp = this->st.mMP;
	this->h.hpp = 0x64;

	if(this->st.mMP == 0)
		this->h.mpp = 0x00;
	else
		this->h.mpp = 0x64;

	
	sprintf(query, "UPDATE char_stats SET mjob = %i, sjob = %i WHERE charid = %i",
		this->st.mJob,this->st.sJob,this->charid);

	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	sprintf(query, "UPDATE char_job SET %s = %i WHERE charid = %i",
		CUtil::getJobString(this->st.mJob),this->st.mLvl,this->charid);

	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	switch(this->st.mJob) {
		case 0x01:
			this->j.war = this->st.mLvl;
			break;
	    case 0x02:
			this->j.mnk = this->st.mLvl;
			break;
		case 0x03:
			this->j.whm = this->st.mLvl;
			break;
		case 0x04:
			this->j.blm = this->st.mLvl;
			break;
		case 0x05:
			this->j.rdm = this->st.mLvl;
			break;
		case 0x06:
			this->j.thf = this->st.mLvl;
			break;
		case 0x07:
			this->j.pld = this->st.mLvl;
			break;
		case 0x08:
			this->j.drk = this->st.mLvl;
			break;
		case 0x09:
			this->j.bst = this->st.mLvl;
			break;
		case 0x0a:
			this->j.brd = this->st.mLvl;
			break;
		case 0x0b:
			this->j.rng = this->st.mLvl;
			break;
		case 0x0c:
			this->j.sam = this->st.mLvl;
			break;
		case 0x0d:
			this->j.nin = this->st.mLvl;
			break;
		case 0x0e:
			this->j.drg = this->st.mLvl;
			break;
		case 0x0f:
			this->j.smn = this->st.mLvl;
			break;
		case 0x10:
			this->j.blu = this->st.mLvl;
			break;
		case 0x11:
			this->j.cor = this->st.mLvl;
			break;
		case 0x12:
			this->j.pup = this->st.mLvl;
			break;
		case 0x13:
			this->j.dnc = this->st.mLvl;
			break;
		case 0x14:
			this->j.sch = this->st.mLvl;
			break;
	}

	return this->st.charStats((unsigned char *)data, num, this->s);
}
void CChar::debugMsg(char * buf, ...){

	CConsole::outTime(" %x %x %x ", this->charid, this->acctid, this->targid);

}

int CChar::stopDld(unsigned char * data, unsigned short num){
	int size = 0;
	
	memset(data+size, 0, 180);
	data[size] = 0x5e;
	data[size+1] = 0x5a;
	memcpy(data+size+2, &num, 2);
	size += 180;

	memset(data+size, 0, 248);
	data[size] = 0x41;
	data[size+1] = 0x7c;
	memcpy(data+size+2, &num, 2);
	data[size+0xf4] = 3;
	size += 248;

	return size;
}

int CChar::dropItem(unsigned char * data, char * in, unsigned short num){
	int size;
	char query[4096];
	MYSQL_RES * res;
	MYSQL_ROW row;
	short id;
	unsigned long count;

	memset(data, 0, 16);
	data[0] = 0x1e;
	data[1] = 0x08;
	memcpy(data+2, &num, sizeof(num));
	data[9] = in[9];
	size = 16;

	memset(data+size, 0, 8);
	data[size] = 0x1d;
	data[size+1] = 0x04;
	memcpy(data+size+2, &num, sizeof(num));
	data[size+4] = 1;
	size += 8;

	sprintf(query, "SELECT item FROM char_inventory WHERE id = %i AND charid = %i",in[9],this->charid);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	//CConsole::outTime(" %s " ,query);
	if(!(res = mysql_store_result(CDb::getConn()))){
		CConsole::outErr("Error looking up equipment");
		return 0;
	}
	if(!mysql_num_rows(res)){
		mysql_free_result(res);
		CConsole::outErr("You don't own that item");
		return 0;
	}

	row = mysql_fetch_row(res);

	id = atoi(row[0]);
	mysql_free_result(res);

	//CConsole::outTime(" %x " ,id);

	memset(data+size, 0, 48);
	data[0+size] = 0x09;
	data[1+size] = 0x12;
	memcpy(data+size+2, &num, sizeof(num));
	data[size+0x0a] = 0xb4;
	
	sprintf((char*)(data+size+13),  "Para0 %i Para1 %i", id, in[4]);

	sprintf(query, "DELETE FROM char_inventory WHERE charid = %i AND location = %i AND id = %i",this->charid,in[8],in[9]);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);
	return size+48;
}

int CChar::sortInv(unsigned char * data, char * in, unsigned short num){
	MYSQL_RES * res;
	MYSQL_ROW row;
	char query[8192];
	unsigned long count;
	unsigned char location;
	char update = 0;
	int size = 0;
	int x = 0;
	std::vector<struct invItem> invList;
	invItem itemData;

	location = in[4];

	sprintf(query, "SELECT item, quantity, id FROM char_inventory WHERE charid = %i AND location = %i",this->charid,location);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	if(!(res = mysql_store_result(CDb::getConn()))){
		CConsole::outErr("Error looking up characters inventory");
	}
	if(!mysql_num_rows(res)){
		mysql_free_result(res);
	}
	else {
		while((row = mysql_fetch_row(res))){
			itemData.itemID = atoi(row[0]);
			itemData.quantity = atoi(row[1]);
			itemData.slotID = atoi(row[2]);
			invList.push_back(itemData);
		}
		mysql_free_result(res);
	}

	for(unsigned int i = 0; i < invList.size(); i++) {
		//REPLACE X WITH THE STACK SIZE OF THE ITEM
		x = 12;
		update = 0;
		if (x > invList.at(i).quantity && invList.at(i).quantity > 0 )
			for(unsigned int a = i+1; a < invList.size(); a++) {
				if (invList.at(i).itemID == invList.at(a).itemID) {
					if ((invList.at(a).quantity + invList.at(i).quantity) > x) {
						invList.at(a).quantity = ((invList.at(i).quantity - x) + invList.at(a).quantity);
						invList.at(i).quantity = x;

						memset(data+size, 0, 0x2C);
						data[size] = 0x20;
						data[size+1] = 0x16;
						memcpy(data+size+2, &num, sizeof(num));
						data[size+4] = invList.at(a).quantity;
						memcpy(data+size+12, &invList.at(a).itemID, 2);
						data[size+14] = location;
						data[size+15] = invList.at(a).slotID;
						size += 0x2c;

						sprintf(query, "UPDATE char_inventory SET quantity = %i , id = %i WHERE charid = %i AND location = %i AND id = %i",invList.at(a).quantity,invList.at(a).slotID,this->charid,location,invList.at(a).slotID);
						count = strlen(query);
						mysql_real_query(CDb::getConn(), query, count);
						update = 1;
						break;
					}
					else {
						invList.at(i).quantity += invList.at(a).quantity;
						invList.at(a).quantity = 0;

						//We can now delete this item
						sprintf(query, "DELETE FROM char_inventory WHERE charid = %i AND location = %i AND id = %i",this->charid,location,invList.at(a).slotID);
						count = strlen(query);
						mysql_real_query(CDb::getConn(), query, count);

						//Remove the item from the clients inventory
						memset(data+size, 0, 0x2C);
						data[size] = 0x20;
						data[size+1] = 0x16;
						memcpy(data+size+2, &num, sizeof(num));
						data[size+4] = invList.at(a).quantity;
						data[size+14] = location;
						data[size+15] = invList.at(a).slotID;
						size += 0x2c;
						update = 1;
					}
				}
			}

			//Check to see if we need to update the item
			if (update == 1) {
				sprintf(query, "UPDATE char_inventory SET quantity = %i , id = %i WHERE charid = %i AND location = %i AND id = %i",invList.at(i).quantity,invList.at(i).slotID,this->charid,location,invList.at(i).slotID);
				count = strlen(query);
				mysql_real_query(CDb::getConn(), query, count);
	
				//Update the item in your inventory
				memset(data+size, 0, 0x2C);
				data[size] = 0x20;
				data[size+1] = 0x16;
				memcpy(data+size+2, &num, sizeof(num));
				data[size+4] = invList.at(i).quantity;
				memcpy(data+size+12, &invList.at(i).itemID, 2);
				data[size+14] = location;
				data[size+15] = invList.at(i).slotID;
				size += 0x2c;
			}
	}

	//Finished modifying our inventory
	memset(data+size, 0, 8);
	data[size] = 0x1d;
	data[size+1] = 4;
	memcpy(data+size+2, &num, sizeof(num));
	data[size+4] = 1;
	size += 8;

	return size;
}

int CChar::moveItem(unsigned char * data, char * in, unsigned short num){
	MYSQL_RES * res;
	MYSQL_ROW row;
	int size = 0, count;
	char query[8192];
	unsigned short item;
	unsigned char oldLocation, oldQuantity, moveID;
	unsigned char id, location, quantity;
	char keepQuantity;
	id = in[10];
	location = in[9];
	oldLocation = in[8];
	quantity = in[4];

	//Find the free ID where we are going to move the item to
	sprintf(query, "SELECT id FROM char_inventory WHERE charid = %i AND location = %i ORDER BY id ASC", this->charid, location);
	count = strlen(query);

	mysql_real_query(CDb::getConn(), query, count);
	moveID = 1;
	if((res = mysql_store_result(CDb::getConn()))){
		if(mysql_num_rows(res)){
			while((row = mysql_fetch_row(res))){
				if ((unsigned int)atoi(row[0]) != moveID){
					break;
				}
				moveID++;
			}
		}
		mysql_free_result(res);
	}

	//Get the Itemid and the previous location of the item to be moved
	sprintf(query, "SELECT item,quantity FROM char_inventory WHERE id = %i AND location = %i AND charid = %i", id,oldLocation,this->charid);
	count = strlen(query);

	mysql_real_query(CDb::getConn(), query, count);

	if(!(res = mysql_store_result(CDb::getConn()))){
		CConsole::outErr("Error looking up itemID");
		return 0;
	}
	if(!mysql_num_rows(res)){
		mysql_free_result(res);
		CConsole::outErr("You don't own that item");
		return 0;
	}

	row = mysql_fetch_row(res);
	item = atoi(row[0]);
	oldQuantity = atoi(row[1]);
	mysql_free_result(res);

	//See if we are trying to move more quantity than we have
	if (quantity > oldQuantity)
		quantity = oldQuantity;

	//Now we update our database to make the move
	sprintf(query, "UPDATE char_inventory SET location = %i , id = %i , quantity = %i WHERE id = %i AND location = %i AND charid = %i",location,moveID,quantity,id,oldLocation,this->charid);
	count = strlen(query);

	mysql_real_query(CDb::getConn(), query, count);

	//Now we just inform the client what has occured

	//If we aren't moving the entire stack we need to keep the old item
	keepQuantity = oldQuantity - quantity;
	if (keepQuantity > 0)
	{
		memset(data+size, 0, 44);
		data[size+0] = 0x20;
		data[size+1] = 0x16;
		memcpy(data+size+2, &num, sizeof(num));
		memcpy(data+size+4, &keepQuantity,sizeof(keepQuantity));
		memcpy(data+size+12, &item,sizeof(item));
		memcpy(data+size+14, &oldLocation,sizeof(oldLocation));
		memcpy(data+size+15, &id,sizeof(id));
		size += 44;

		//We need to re-add the remaining quantity back to the orignal location
		sprintf(query, "INSERT INTO char_inventory (charid, id, location, quantity, item) VALUES (%i,%i,%i,%i,%i)",this->charid,id,oldLocation,keepQuantity,item);
		count = strlen(query);

	}
	else {
		//Remove the item from the orignal location
		memset(data+size, 0, 44);
		data[size+0] = 0x20;
		data[size+1] = 0x16;
		memcpy(data+size+2, &num, sizeof(num));
		memcpy(data+size+14, &oldLocation,sizeof(oldLocation));
		data[size+0x0F] = id;
		size += 44;
	}

	//Add the item to the destination
	memset(data+size, 0, 44);
	data[size] = 0x20;
	data[size+1] = 0x16;
	memcpy(data+size+2, &num, sizeof(num));
	memcpy(data+size+4,&quantity,sizeof(quantity));
	memcpy(data+size+12, &item,sizeof(item));
	memcpy(data+size+14,&location,sizeof(location));
	memcpy(data+size+15,&moveID,sizeof(moveID));
	size += 44;

	//Tell the client where we put the item
	memset(data+size, 0, 28);
	data[size] = 0x26;
	data[size+1] = 0x0E;
	memcpy(data+size+2, &num, sizeof(num));
	memcpy(data+size+5,&moveID,sizeof(moveID));
	size += 28;

	//Tell the client we are done
	memset(data+size, 0, 8);
	data[size] = 0x1d;
	data[size+1] = 4;
	memcpy(data+size+2, &num, sizeof(num));
	data[size+4] = 1;
	size += 8;

	return size;
}


int CChar::spawnPCs(unsigned char * data, unsigned short num){
	CChar * ochar = this;
	CChar * schar;
	unsigned int size = 0, status = 0;

		
	for(schar = CChar::first.next; schar != 0; schar = schar->next){
		if(schar->loc.zone == ochar->loc.zone &&  schar->charid != ochar->charid ){
	
		if(CUtil::distance(schar->loc.p, ochar->loc.p) < 50){

				unsigned short targ = schar->currTarg;
				targ *=2;

				memset(data+size, 0, 96);
				data[size] = 0x0d;
				data[size+1] = 0x30;
				memcpy(data+size+2, &num, sizeof(num));
				memcpy(data+size+4, &(schar->charid), sizeof(schar->charid));
				memcpy(data+size+8, &(schar->targid), sizeof(schar->targid));
				data[size+0x0A] = 0x1F;
				data[size+0x0B] = (unsigned char)schar->loc.p.rotation;
				memcpy(data+size+0x0C, &(schar->loc.p.x), sizeof(float)*3);
				memcpy(data+size+0x1a, &targ, sizeof(targ));
				memcpy(data+size+0x18, &(schar->movCount), sizeof(unsigned short));
				data[size+0x1C] = 0x28;
				data[size+0x1D] = 0x28;
				data[size+0x1E] = schar->h.hpp;
				data[size+0x1F] = schar->h.animation;
				status = ((schar->h.status & 0xff000000) >> 5) + ((schar->h.status & 0x000000ff) << 7);
				
				memcpy(data+size+0x20, &(status), sizeof(int));
				memcpy(data+size+0x3E, &(schar->l), sizeof(schar->l));
				memcpy(data+size+0x40, &(schar->l.head), 2);
				memcpy(data+size+0x42, &(schar->l.body), 2);
				memcpy(data+size+0x44, &(schar->l.hands), 2);
				memcpy(data+size+0x46, &(schar->l.legs), 2);
				memcpy(data+size+0x48, &(schar->l.feet), 2);
				memcpy(data+size+0x4A, &(schar->l.main), 2);
				memcpy(data+size+0x4C, &(schar->l.sub), 2);
				memcpy(data+size+0x4E, &(schar->l.range), 2);
				memcpy(data+size+0x50, &(schar->charname), 16);
				//data[size+0x20] = 0x01;
				size += 96;
			
			}
		}
	}
	return size;
}


int CChar::recvChat(unsigned char * data, unsigned short num, CComm * comm){

	unsigned long count=0;
	unsigned long lenght = 0;

	switch(comm->ident) {

		case 0x03:
			lenght = comm->lenght*2-20;
			count =  lenght + 21;
			memset(data, 0, count+2);
			memcpy(data+21, comm->message, lenght);
			break;

		case 0x07:
			lenght = strlen(comm->pData.c);
			count =  lenght + 22;
			memset(data, 0, count+2);
			memcpy(data+21, comm->pData.uc, lenght);
			break;

		default:

			lenght = comm->lenght*2-6;
			count =  lenght + 21;
			CConsole::outTime("%s: %s ", comm->fromc, comm->message);
			Sleep(400);
			memset(data, 0, count+2);
			memcpy(data+21, comm->message, lenght);
			break;

	}
	
	data[0] = 0x17;
	data[1] = (unsigned char)(count+(comm->ident == 3 ? 0 : 1))/2;
	memcpy(data+2, &num, sizeof(num));
	memcpy(data+5, comm->fromc, 16);
	data[20] = comm->ident;



	return (int)count;
}

int CChar::sendErr(unsigned char * data, unsigned short num, unsigned short n){
	memset(data, 0, 16);
	data[0] = 0x9;
	data[1] = 8;
	memcpy(data+2, &n, sizeof(n));
	memcpy(data+10, &num, sizeof(num));

	return 16;
}



// load a char
int CChar::loadChar(int charid) {
	int count;
	MYSQL_RES * res;
	MYSQL_ROW row;
	char query[8192];
	unsigned long * lengths;


	sprintf(query, "SELECT charname, charid, acctid, ip, servip, sessionkey, keyitems, firstlogin, targid, pos_zone, pos_x, pos_y, pos_z, pos_prevzone, pos_rot, gil, size_inv, size_mog, size_locker, size_storage, hp_zone, hp_x, hp_y, hp_z, nation, rank_san, rank_bas, rank_win, fame_san, fame_bas, fame_win, fame_norg FROM chars WHERE charid = %i",charid);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	if(!(res = mysql_store_result(CDb::getConn())))
		return 0;
 
	if(row = mysql_fetch_row(res)) {
		lengths = mysql_fetch_lengths(res);

	
	/*	memcpy((char *)&(this->l), row[12], lengths[12]);
		memcpy((char *)&(this->j), row[13], lengths[13]);
		memcpy((char *)&(this->s), row[14], lengths[14]);
		memcpy((char *)&(this->st), row[15], lengths[15]);

		memcpy((char *)&(this->e), row[19], lengths[19]);
		memcpy((char *)&(this->inv), row[20], lengths[20]);
		memcpy((char *)&(this->k), row[21], lengths[21]);
		*/

		memset(this->charname,0,16);
		memcpy(this->charname, row[0], lengths[0]);
		this->charid			= atoi(row[1]);
		this->acctid			= atoi(row[2]);

		memcpy((char *)&(this->ip), row[3], lengths[3]);
		memcpy((char *)&(this->servip), row[4], lengths[4]);
		memcpy((char *)(this->enc.key), row[5], lengths[5]);
		memcpy((char *)&(this->k),row[6],lengths[6]);
		this->firstlogin		= atoi(row[7]);

		this->targid			= atoi(row[8]);
		this->loc.zone			= atoi(row[9]);
		this->loc.p.x			= (float)atof(row[10]);
		this->loc.p.y			= (float)atof(row[11]);
		this->loc.p.z			= (float)atof(row[12]);
		this->loc.prevzone		= atoi(row[13]);
		this->loc.p.rotation	= atoi(row[14]);
		this->inv.gil			= atoi(row[15]);
		this->inv.invsize		= atoi(row[16]);
		this->inv.mogsize		= atoi(row[17]);
		this->inv.lockersize	= atoi(row[18]);
		this->inv.storagesize	= atoi(row[19]);
		this->hp.homepoint		= atoi(row[20]);
		this->st.homepoint		= this->hp.homepoint;
		
		this->hp.x				= (float)atof(row[21]);
		this->hp.y				= (float)atof(row[22]);
		this->hp.z				= (float)atof(row[23]);
		this->st.n.home			= atoi(row[24]);
		this->st.n.rank[0]		= atoi(row[25]);
		this->st.n.rank[1]		= atoi(row[26]);
		this->st.n.rank[2]		= atoi(row[27]);
		this->fameSan			= atoi(row[28]);
		this->fameBas			= atoi(row[29]);
		this->fameWin			= atoi(row[30]);
		this->fameNorg			= atoi(row[31]);

		// 2008/09/04 UԊuݒ Add-Start
		// UԊulݒ
		this->atkdelay			= 0;
		// 2008/09/04 UԊuݒ Add-End
		// 2008/09/04 ړxݒ Add-Start
		// ړxlݒ
		this->charspd			= 0x28;
		// 2008/09/04 ړxݒ Add-End

		this->locked = false;
		this->commListLocked = false;
	}
	else {
		CConsole::outErr("Not Found !!!");
	}

	mysql_free_result(res);

	memset(query, 0, 2000);
	sprintf(query, "SELECT hp, mp, animation, status, mjob, sjob FROM char_stats WHERE charid = %i", this->charid);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	if(!(res = mysql_store_result(CDb::getConn())))
		return 0;
 
	if(row = mysql_fetch_row(res)) {
		lengths = mysql_fetch_lengths(res);

		this->h.hp			= atoi(row[0]);
		this->h.mp			= atoi(row[1]);
		this->h.animation	= atoi(row[2]);
		this->h.status		= atoi(row[3]);
		this->st.mJob		= atoi(row[4]);
		this->st.sJob		= atoi(row[5]);

	}

	mysql_free_result(res);
	memset(query, 0, 2000);
	sprintf(query, "SELECT face, race, head, body, hands, legs, feet, main, sub, range FROM char_look where charid = %i",this->charid);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);
	
	if(!(res = mysql_store_result(CDb::getConn())))
		return 0;

	if(row = mysql_fetch_row(res)) {
		this->l.face	= atoi(row[0]);
		this->l.race	= atoi(row[1]);
		this->l.head	= atoi(row[2]);
		this->l.body	= atoi(row[3]);
		this->l.hands	= atoi(row[4]);
		this->l.legs	= atoi(row[5]);
		this->l.feet	= atoi(row[6]);
		this->l.main	= atoi(row[7]);
		this->l.sub		= atoi(row[8]);
		this->l.range	= atoi(row[9]);
	}

	mysql_free_result(res);

	memset(query, 0, 2000);
	sprintf(query, "SELECT main, sub, ranged, ammo, head, body, hands, legs, feet, neck, waist, ear1, ear2, ring1, ring2, back FROM char_equip where charid = %i",this->charid);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);
	
	if(!(res = mysql_store_result(CDb::getConn())))
		return 0;

	if(row = mysql_fetch_row(res)) {
		for(int i=0;i<16;i++) {
			this->e.SlotID[i] = atoi(row[i]);
		}
	}

	mysql_free_result(res);

	for(int i=0;i<16;i++) {
		memset(query, 0, 2000);
		sprintf(query, "SELECT item FROM char_inventory WHERE charid = %i AND id = %i AND location = 0",this->charid,this->e.SlotID[i]);
		count = strlen(query);
		mysql_real_query(CDb::getConn(), query, count);
		if(!(res = mysql_store_result(CDb::getConn())))
			return 0;

		if(row = mysql_fetch_row(res)) {
			this->e.ItemID[i] = atoi(row[0]);
		}
		mysql_free_result(res);
	}

	memset(query, 0, 2000);
	sprintf(query, "SELECT unlocked, reserved, war, mnk, whm, blm, rdm, thf, pld, drk, bst, brd, rng, sam, nin, drg, smn, blu, cor, pup, dnc, sch FROM char_job where charid = %i",this->charid);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);
	
	if(!(res = mysql_store_result(CDb::getConn())))
		return 0;

	if(row = mysql_fetch_row(res)) {
		this->j.unlocked = atoi(row[0]);
		this->j.reserved = atoi(row[1]);
		this->j.war = atoi(row[2]);
		this->j.mnk = atoi(row[3]);
		this->j.whm = atoi(row[4]);
		this->j.blm = atoi(row[5]);
		this->j.rdm = atoi(row[6]);
		this->j.thf = atoi(row[7]);
		this->j.pld = atoi(row[8]);
		this->j.drk = atoi(row[9]);
		this->j.bst = atoi(row[10]);
		this->j.brd = atoi(row[11]);
		this->j.rng = atoi(row[12]);
		this->j.sam = atoi(row[13]);
		this->j.nin = atoi(row[14]);
		this->j.drg = atoi(row[15]);
		this->j.smn = atoi(row[16]);
		this->j.blu = atoi(row[17]);
		this->j.cor = atoi(row[18]);
		this->j.pup = atoi(row[19]);
		this->j.dnc = atoi(row[20]);
		this->j.sch = atoi(row[21]);
		this->st.mLvl = atoi(row[this->st.mJob+1]);
	
	}
	
	mysql_free_result(res);

	memset(query, 0, 2000);
	sprintf(query, "SELECT h2h, dagger, sword, gsword, axe, gaxe, sythe, polarm, katana, gkatana, club, staff, reserved1, reserved2, reserved3, reserved4, reserved5, reserved6, reserved7, reserved8, reserved9, reserved10, reserved11, reserved12, archery, marksmanship, throwing, guarding, evasion, shield, parrying, divine, healing, enhancing, enfeebling, elemental, dark, summoning, ninjutsu, singing, string, wind FROM char_skills where charid = %i",this->charid);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);	
	if(!(res = mysql_store_result(CDb::getConn())))
		return 0;

	if(row = mysql_fetch_row(res)) {
		this->s.h2h = atoi(row[0]);
		this->s.daggar = atoi(row[1]);
		this->s.sword = atoi(row[2]);
		this->s.gsword = atoi(row[3]);
		this->s.axe = atoi(row[4]);
		this->s.gaxe = atoi(row[5]);
		this->s.sythe = atoi(row[6]);
		this->s.polarm = atoi(row[7]);
		this->s.katana = atoi(row[8]);
		this->s.gkatana = atoi(row[9]);
		this->s.club = atoi(row[10]);
		this->s.staff = atoi(row[11]);
		this->s.reserved[0] = atoi(row[12]);
		this->s.reserved[1] = atoi(row[13]);
		this->s.reserved[2] = atoi(row[14]);
		this->s.reserved[3] = atoi(row[15]);
		this->s.reserved[4] = atoi(row[16]);
		this->s.reserved[5] = atoi(row[17]);
		this->s.reserved[6] = atoi(row[18]);
		this->s.reserved[7] = atoi(row[19]);
		this->s.reserved[8] = atoi(row[20]);
		this->s.reserved[9] = atoi(row[21]);
		this->s.reserved[10] = atoi(row[22]);
		this->s.reserved[11] = atoi(row[23]);
		this->s.archery = atoi(row[24]);
		this->s.marksmanship = atoi(row[25]);
		this->s.throwing = atoi(row[26]);
		this->s.guarding = atoi(row[27]);
		this->s.evasion = atoi(row[28]);
		this->s.shield = atoi(row[29]);
		this->s.parrying = atoi(row[30]);
		this->s.divine = atoi(row[31]);
		this->s.healing = atoi(row[32]);
		this->s.enhancing = atoi(row[33]);
		this->s.enfeebling = atoi(row[34]);
		this->s.elemental = atoi(row[35]);
		this->s.dark = atoi(row[36]);
		this->s.summoning = atoi(row[37]);
		this->s.ninjutsu = atoi(row[38]);
		this->s.singing = atoi(row[39]);
		this->s.string = atoi(row[40]);
		this->s.wind = atoi(row[41]);
	}

	this->st.calcStats(this->l);
	mysql_free_result(res);
	return 1;
}

// saves a new char to DB
int CChar::createChar() {
	int count;
	char query[8096];
	unsigned short fl = 0x01;
	MYSQL_RES * res;
	MYSQL_ROW row;

	memset(query,0,8096);
	//remove duplicate characters
	sprintf(query, "DELETE FROM chars WHERE charid = %i",this->charid);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	memset(query,0,8096);
	sprintf(query, "DELETE FROM char_look WHERE charid = %i",this->charid);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	memset(query,0,8096);
	sprintf(query, "DELETE FROM char_stats WHERE charid = %i",this->charid);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	memset(query,0,8096);
	sprintf(query, "DELETE FROM char_equip WHERE charid = %i",this->charid);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	memset(query,0,8096);
	sprintf(query, "DELETE FROM char_job WHERE charid = %i",this->charid);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);	

	memset(query,0,8096);
	sprintf(query, "DELETE FROM char_skills WHERE charid = %i",this->charid);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	memset(query,0,8096);
	strcpy(query, "SELECT MAX(targid) FROM chars");
	mysql_real_query(CDb::getConn(), query, strlen(query));
	short targid = 0x400;
	if((res = mysql_store_result(CDb::getConn()))){
		if(mysql_num_rows(res)){
			row = mysql_fetch_row(res);
			if(row[0]){
				targid = atoi(row[0]);
				targid++;
			}
		}
		mysql_free_result(res);
	}
	this->targid = targid;


	sprintf(query, "INSERT INTO chars (udate, acctid, charid, targid, charname, firstlogin, pos_x, pos_y, pos_z, pos_zone, pos_prevzone, pos_rot, gil, size_inv, size_mog, size_locker, size_storage, hp_zone, hp_x, hp_y, hp_z, nation, rank_san, rank_bas, rank_win, fame_san, fame_bas, fame_win, fame_norg, ip, servip, sessionkey, keyitems) VALUES (CURRENT_TIMESTAMP,%i,%i,%i,'%s',%i,%f,%f,%f,%i,%i,%i,%i,%i,%i,%i,%i,%i,%f,%f,%f,%i,%i,%i,%i,%i,%i,%i,%i,'",
		this->acctid,this->charid,this->targid, this->charname, fl,this->loc.p.x,this->loc.p.y,this->loc.p.z,this->loc.zone,this->loc.prevzone,(unsigned char)this->loc.p.rotation,this->inv.gil,this->inv.invsize,this->inv.mogsize,this->inv.lockersize,this->inv.storagesize,this->hp.homepoint,this->hp.x,this->hp.y,this->hp.z,this->st.n.home,this->st.n.rank[0],this->st.n.rank[1],this->st.n.rank[2],this->fameSan,this->fameBas,this->fameWin,this->fameNorg);

	count = strlen(query);
	count += mysql_real_escape_string(CDb::getConn(), query+count, (char *)&(this->ip), sizeof(unsigned int));		//ip
	strcpy(query+count, "', '");
	count += 4;
	count += mysql_real_escape_string(CDb::getConn(), query+count, (char *)&(this->servip), sizeof(unsigned int));	//servip
	strcpy(query+count, "', '");
	count += 4;
	count += mysql_real_escape_string(CDb::getConn(), query+count, (char *)&(this->enc.key), 20);			//sessionkey
	strcpy(query+count, "', '");
	count += 4;
	count += mysql_real_escape_string(CDb::getConn(), query+count, (char *)&(this->k), 128);				//keyitems
	strcpy(query+count, "')");
	count += 2;
	mysql_real_query(CDb::getConn(), query, count);

	memset(query,0,8096);
	sprintf(query, "INSERT INTO char_stats (charid, hp,  mp,  animation, status, mjob, sjob) VALUES (%i,%i,%i,%i,%i,%i,%i)",
			this->charid, this->h.hp, this->h.mp, this->h.animation, this->h.status,this->st.mJob,this->st.sJob);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	memset(query,0,8096);
	sprintf(query, "INSERT INTO char_look (charid, face, race, head, body, hands, legs, feet, main, sub, range) VALUES (%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i)",
		this->charid, this->l.face, this->l.race, this->l.head, this->l.body, this->l.hands, this->l.legs,this->l.feet,this->l.main,this->l.sub,this->l.range);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	memset(query,0,8096);
	sprintf(query, "INSERT INTO char_equip (charid, main, sub, ranged, ammo, head, body, hands, legs, feet, neck, waist, ear1, ear2, ring1, ring2, back) VALUES (%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i)",
		this->charid, this->e.SlotID[0], this->e.SlotID[1], this->e.SlotID[2], this->e.SlotID[3], this->e.SlotID[4], this->e.SlotID[5],this->e.SlotID[6],this->e.SlotID[7],this->e.SlotID[8],this->e.SlotID[9],this->e.SlotID[10],this->e.SlotID[11],this->e.SlotID[12],this->e.SlotID[13],this->e.SlotID[14],this->e.SlotID[15]);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	memset(query,0,8096);
	sprintf(query, "INSERT INTO char_job (charid, unlocked, reserved, war, mnk, whm, blm, rdm, thf, pld, drk, bst, brd, rng, sam, nin, drg, smn, blu, cor, pup, dnc, sch) VALUES (%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i)",
		this->charid, this->j.unlocked, this->j.reserved, this->j.war, this->j.mnk, this->j.whm, this->j.blm,this->j.rdm,this->j.thf,this->j.pld,this->j.drk,this->j.bst,this->j.brd,this->j.rng,this->j.sam,this->j.nin,this->j.drg,this->j.smn,this->j.blu,this->j.cor,this->j.pup,this->j.dnc,this->j.sch);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	memset(query,0,8096);
	sprintf(query, "INSERT INTO char_skills (charid, h2h, dagger, sword, gsword, axe, gaxe, sythe, polarm, katana, gkatana, club, staff, reserved1, reserved2, reserved3, reserved4, reserved5, reserved6, reserved7, reserved8, reserved9, reserved10, reserved11, reserved12, archery, marksmanship, throwing, guarding, evasion, shield, parrying, divine, healing, enhancing, enfeebling, elemental, dark, summoning, ninjutsu, singing, string, wind) VALUES (%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i)",
		this->charid, this->s.h2h, this->s.daggar, this->s.sword, this->s.gsword, this->s.axe, this->s.gaxe, this->s.sythe,this->s.polarm,this->s.katana,this->s.gkatana,this->s.club,this->s.staff,this->s.reserved[0],this->s.reserved[1],this->s.reserved[2],this->s.reserved[3],this->s.reserved[4],this->s.reserved[5],this->s.reserved[6],this->s.reserved[7],this->s.reserved[8],this->s.reserved[9],this->s.reserved[10],this->s.reserved[11],this->s.archery,this->s.marksmanship,this->s.throwing,this->s.guarding,this->s.evasion,this->s.shield,this->s.parrying,this->s.divine,this->s.healing,this->s.enhancing,this->s.enfeebling,this->s.elemental,this->s.dark,this->s.summoning,this->s.ninjutsu,this->s.singing,this->s.string,this->s.wind);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);

	return 0;
}

// write char to DB
int CChar::writeChar() {
	int count;
	char query[8096];

	count = sprintf(query, "UPDATE chars SET udate = CURRENT_TIMESTAMP, acctid = %i, targid = %i, charname = '%s', firstlogin = %i, pos_x = %f, pos_y = %f, pos_z = %f, pos_zone = %i, pos_prevzone = %i, pos_rot = %i, gil = %i, size_inv = %i, size_mog = %i, size_locker = %i, size_storage = %i, hp_zone = %i, hp_x = %f, hp_y = %f, hp_z = %f, nation = %i, rank_san = %i, rank_bas = %i, rank_win = %i, fame_san = %i, fame_bas = %i, fame_win = %i, fame_norg = %i, ip = '",
				this->acctid,this->targid, this->charname, 0,this->loc.p.x,this->loc.p.y,this->loc.p.z,this->loc.zone,this->loc.prevzone,this->loc.p.rotation,this->inv.gil,this->inv.invsize,this->inv.mogsize,this->inv.lockersize,this->inv.storagesize,this->hp.homepoint,this->hp.x,this->hp.y,this->hp.z,this->st.n.home,this->st.n.rank[0],this->st.n.rank[1],this->st.n.rank[2],this->fameSan,this->fameBas,this->fameWin,this->fameNorg);

	count += mysql_real_escape_string(CDb::getConn(), query+count, (char *)&(this->ip), sizeof(unsigned int));		//ip
	strcpy(query+count, "', servip = '");
	count += 13;
	count += mysql_real_escape_string(CDb::getConn(), query+count, (char *)&(this->servip), sizeof(unsigned int));	//servip
	strcpy(query+count, "', sessionkey = '");
	count += 17;
	count += mysql_real_escape_string(CDb::getConn(), query+count, (char *)&(this->enc.key), 20);			//sessionkey
	strcpy(query+count, "', keyitems = '");
	count += 15;
	count += mysql_real_escape_string(CDb::getConn(), query+count, (char *)&(this->k), 128);				//keyitems

	count += sprintf(query+count, "' WHERE charid = %i",this->charid);
	mysql_real_query(CDb::getConn(), query, count);

	memset(query,0,8096);
	count = sprintf(query, "UPDATE char_stats SET hp = %i, mp = %i, animation = %i, status = %i, mjob = %i, sjob = %i WHERE charid = %i",
				this->h.hp, this->h.mp, this->h.animation, this->h.status,this->st.mJob,this->st.sJob,this->charid);
	mysql_real_query(CDb::getConn(), query, count);

	memset(query,0,8096);
	count = sprintf(query, "UPDATE char_look SET face = %i, race = %i, head = %i, body = %i, hands = %i, legs = %i, feet = %i, main = %i, sub = %i, range = %i WHERE charid = %i",
				this->l.face, this->l.race, this->l.head, this->l.body, this->l.hands, this->l.legs,this->l.feet,this->l.main,this->l.sub,this->l.range,this->charid);
	mysql_real_query(CDb::getConn(), query, count);

	memset(query,0,8096);
	count = sprintf(query, "UPDATE char_equip SET main = %i, sub = %i, ranged = %i, ammo = %i, head = %i, body = %i, hands = %i, legs = %i, feet = %i, neck = %i, waist = %i, ear1 = %i, ear2 = %i, ring1 = %i, ring2 = %i, back = %i WHERE charid = %i",
				this->e.SlotID[0], this->e.SlotID[1], this->e.SlotID[2], this->e.SlotID[3], this->e.SlotID[4], this->e.SlotID[5],this->e.SlotID[6],this->e.SlotID[7],this->e.SlotID[8],this->e.SlotID[9],this->e.SlotID[10],this->e.SlotID[11],this->e.SlotID[12],this->e.SlotID[13],this->e.SlotID[14],this->e.SlotID[15],this->charid);
	mysql_real_query(CDb::getConn(), query, count);

	memset(query,0,8096);
	count = sprintf(query, "UPDATE char_job SET unlocked = %i, reserved = %i, war = %i, mnk = %i, whm = %i, blm = %i, rdm = %i, thf = %i, pld = %i, drk = %i, bst = %i, brd = %i, rng = %i, sam = %i, nin = %i, drg = %i, smn = %i, blu = %i, cor = %i, pup = %i, dnc = %i, sch = %i WHERE charid = %i",
				this->j.unlocked, this->j.reserved, this->j.war, this->j.mnk, this->j.whm, this->j.blm,this->j.rdm,this->j.thf,this->j.pld,this->j.drk,this->j.bst,this->j.brd,this->j.rng,this->j.sam,this->j.nin,this->j.drg,this->j.smn,this->j.blu,this->j.cor,this->j.pup,this->j.dnc,this->j.sch,this->charid);
	mysql_real_query(CDb::getConn(), query, count);

	memset(query,0,8096);
	count = sprintf(query, "UPDATE char_skills SET h2h = %i, dagger = %i, sword = %i, gsword = %i, axe = %i, gaxe = %i, sythe = %i, polarm = %i, katana = %i, gkatana = %i, club = %i, staff = %i, reserved1 = %i, reserved2 = %i, reserved3 = %i, reserved4 = %i, reserved5 = %i, reserved6 = %i, reserved7 = %i, reserved8 = %i, reserved9 = %i, reserved10 = %i, reserved11 = %i, reserved12 = %i, archery = %i, marksmanship = %i, throwing = %i, guarding = %i, evasion = %i, shield = %i, parrying = %i, divine = %i, healing = %i, enhancing = %i, enfeebling = %i, elemental = %i, dark = %i, summoning = %i, ninjutsu = %i, singing = %i, string = %i, wind = %i WHERE charid = %i",
				this->s.h2h, this->s.daggar, this->s.sword, this->s.gsword, this->s.axe, this->s.gaxe, this->s.sythe,this->s.polarm,this->s.katana,this->s.gkatana,this->s.club,this->s.staff,this->s.reserved[0],this->s.reserved[1],this->s.reserved[2],this->s.reserved[3],this->s.reserved[4],this->s.reserved[5],this->s.reserved[6],this->s.reserved[7],this->s.reserved[8],this->s.reserved[9],this->s.reserved[10],this->s.reserved[11],this->s.archery,this->s.marksmanship,this->s.throwing,this->s.guarding,this->s.evasion,this->s.shield,this->s.parrying,this->s.divine,this->s.healing,this->s.enhancing,this->s.enfeebling,this->s.elemental,this->s.dark,this->s.summoning,this->s.ninjutsu,this->s.singing,this->s.string,this->s.wind,this->charid);
	mysql_real_query(CDb::getConn(), query, count);

	return 0;
}

int CChar::check(unsigned char * data, char * in, unsigned short num){
	CChar * spchar = new CChar();
	int i=0, count2=0, size = 0;

	unsigned int cid;
	memcpy(&cid, in+4, sizeof(unsigned int));

	spchar = CChar::getCChar(cid, "", 0);

	if(!spchar){
		CConsole::outErr("/check -> Character not found!");
		return 0;
	}
		
	memset(data, 0, 552+148);
	
	/*data[0] = 0xCA;
	data[1] = 0x4A;
	memcpy(data+2, &num, sizeof(num));
	data[0x7f] = 0x1E;
	memcpy(data+0x80, this->id.charname, 16);
	data[0x90] = 0xCE;
	size = 148;*/

	data[size] = 0xC9;
	memcpy(data+2+size, &num, sizeof(num));
	memcpy(data+4+size, in+4, 6);
	data[10+size] = 0x03;
	data[11+size] = 0x04;
	size += 12;

	for(i=0;i<8;i++) {
		if(spchar->e.ItemID[i] != 0){
			memcpy(data+size, (char *)&(spchar->e.ItemID[i]), sizeof(short));
			data[size+2] = i;
			size += 28;
		}
	}
	data[1] = (size/2);
	
	count2 = size;
	data[size] = 0xC9;
	data[1+size] = 0x76;
	memcpy(data+2+size, &num, sizeof(num));
	memcpy(data+4+size, in+4, 6);
	data[10+size] = 0x03;
	data[11+size] = 0x04;
	size += 12;

	for(i=8;i<16;i++) {
		if(spchar->e.ItemID[i] != 0){
			memcpy(data+size, (char *)&(spchar->e.ItemID[i]), sizeof(short));
			data[size+2] = i;
			size += 28;
		}
	}
	data[count2+1] = ((size-count2)/2);

	data[size] = 0xC9;
	data[1+size] = 0x28;
	memcpy(data+2+size, &num, sizeof(num));
	memcpy(data+4+size, in+4, 6);
	
	data[10+size] = 0x01;

	if(!(spchar->h.status & FLAG_ANON)){
		data[18+size] = spchar->st.mJob;
		data[19+size] = spchar->st.sJob;
		data[35+size] = spchar->st.mLvl;
		data[36+size] = spchar->st.sLvl;
	}
	size += 0x50;

	CChar * tmpChar = new CChar();
	CComm * comm = new CComm();
	comm->setComType(0x09);
	sprintf((char *)comm->fromc, "string2 %s ", this->charname);
	comm->ident = 0x59;
	unsigned int id;
	memcpy(&id, in+4, sizeof(unsigned int));
	CChar::getCChar(id, "",0)->addCommList(*comm);

	return size;
}

int CChar::stdmRecv(unsigned char * data, CComm * comm, unsigned short num){

	memset(data, 0, 48);
	data[0] = 0x09;
	data[1] = 0x30;
	memcpy(data+2, &num, sizeof(num));
	data[10]= comm->ident;

	//if the message is a check message add the "string2 <name>"
	if((comm->ident == 0x59)||(comm->ident == 0x58)) 
	{
		strcpy((char*)(data+13), (const char *)comm->fromc);
	}

	return 48;
}

int CChar::emote(unsigned char * data, char * in, unsigned short num){

	char emote[22];

	memcpy(emote, in, 16);
	memcpy(emote+16, &(this->targid), 2);
	memcpy(emote+18, &(this->charid), 4);
				
	CComm comm;
	comm.setComType(0x5d);
	comm.ident = 0x03;
	memcpy(comm.emote, emote, 22);
	memcpy(comm.emote+22, &(this->e.ItemID), 2);
	comm.charid = this->charid;

	memcpy(comm.fromc, this->charname, 16);
	this->insertComm(CHAR_INRANGE_SELF, comm);


	return 0;
}

int CChar::emoteRecv(unsigned char * data, CComm * comm, unsigned short num){
	int size = 0;
	int item = 0;

	memset(data+size, 0, 24);
	data[size] = 0x5A;
	data[size+1] = 0x0C;
	memcpy(data+size+2, &num, sizeof(num));
	memcpy(data+size+4,  comm->emote+18,  4);
	memcpy(data+size+8,   comm->emote+4,   4);
	memcpy(data+size+12,  comm->emote+16,  2);
	memcpy(data+size+14,  comm->emote+8,   3);

	memcpy(&item,comm->emote+22,2);
	if(item == 0x40ee) {
		comm->emote[23] = 0x47;
		comm->emote[22] = 0x6A;
	}	
	memcpy(data+size+18,  comm->emote+22,   2);

	data[size+20] = comm->emote[11];
	size += 24;


	return size;
}

int CChar::servmesResp(unsigned char * data, unsigned short num) {

		data[0] = 0x4D;
		data[1] = 0x0E;
		memcpy(data+2, &num, sizeof(num));
		data[4] = 0x01; data[5] = 0x01; data[6] = 0x01;
		data[7] = 0x02; data[8] = 0x67; data[9] = 0x25;
		data[10]= 0xD8; data[11]= 0x47; data[12]= 0x02;
		data[20]= 0x02; data[24]= 0x20;

		return 28;
}


int CChar::updatePCs(unsigned char * data, CComm * comm, unsigned short num){
	
	int size = 0;
	CChar * schar = (CChar*) comm->ptr;

	unsigned short targ = schar->currTarg;
	targ *=2;

	memset(data+size, 0, 96+40);
	data[size] = 0x0d;
	data[size+1] = 0x2a;
	memcpy(data+size+2, &num, sizeof(num));
	memcpy(data+size+4, &(schar->charid), sizeof(schar->charid));
	memcpy(data+size+8, &(schar->targid), sizeof(schar->targid));
	data[size+0x0A] = 0x20;
	size += 84;

	return size;
}

int CChar::diceroll(unsigned char * data, unsigned short num){
	int n;
	char number[4];
	 
	srand((int)rand()*clock());

	n=1+(int)(rand()%1000); 
	itoa(n, number, 10);


	CComm * comm = new CComm();
	comm->setComType(0x09);
	comm->ident = 0x58;
	sprintf((char *)comm->fromc, "string2 %s string3 %s", this->charname, number);
	this->insertComm(CHAR_INRANGE_SELF, *comm);
	

	return 0;
}

int CChar::tsit(unsigned char * data, char * in, unsigned short num){

	if(this->h.animation == 0x2f)
		this->h.animation = 0;
	else
		this->h.animation = 0x2f;

	return updateChar((unsigned char *)data, num);
}


int CChar::updateChar(unsigned char * data,  unsigned short num){

	unsigned long  i;
	//Temporary fix to a weird problem
	if (this->charid == 0) return 0;

	memset(data, 0, 80);
	data[0] = 0x37;
	data[1] = 0x28;
	memcpy(data+2, &num, sizeof(num));
	for (i = 0; i < 32; i++ ){
		data[4+i] = 0xFF;
	}
	
	data[0x28] = 0x08;
	data[0x29] = 0x05;
	data[0x2a] = 0x64;
	
	data[0x31] = 0x38;
	data[0x32] = 0x38;
	data[0x33] = 0x38;

	data[0x3c] = 0x20;
	data[0x3d] = 0xa0;
	data[0x3e] = 0x03;
	
	// 2008/09/04 ړxݒ Mod-Start
	//data[44] = 0x28;

	// ړxŒlݒlgpɕύX
	data[44] = this->charspd;
	// 2008/09/04 ړxݒ Mod-End

	
	data[0x30] = this->h.animation;
	memcpy(data+36, &(this->charid), sizeof(this->charid));
	memcpy(data+0x28, &(this->h.status), sizeof(int));

	//sprintf(query, "UPDATE char_stats SET status = %i, animation =%i WHERE charid = %i",this->h.status,this->h.animation,this->charid);
	//count = strlen(query);
	//mysql_real_query(CDb::getConn(), query, count);
	
	return 80;
}

int CChar::seekAnon(unsigned char * data, char * in, unsigned short num){
	int type;

	if(in[4] == 0x01)
		this->h.status ^= FLAG_INVITE;
	else {
		this->h.status ^= FLAG_ANON;

		if(this->h.status & FLAG_ANON)
			type = 0xAF;
		else
			type = 0xB0;

		CComm * comm = new CComm();
		comm->setComType(0x09);
		comm->ident = type;
		comm->charid = this->charid;
		this->insertComm(CHAR_INRANGE_SELF, *comm);
	}

	return updateChar((unsigned char *)data, num);
}

int CChar::updateInvSize(unsigned char * data,  unsigned short num){

	memset(data, 0, (0x0A*2));
	data[0] = 0x1C;
	data[1] = 0x0A;
	memcpy(data+2, &num, sizeof(num));

	data[4] = this->inv.invsize+1;
	data[5] = this->inv.mogsize+1;
	data[6] = this->inv.storagesize+1;

	data[10] = this->inv.invsize+1;
	data[12] = this->inv.mogsize+1;
	data[14] = this->inv.storagesize+1;

	return (0x0A*2);
}

int CChar::cmJobMog(unsigned char * data,  char * in, unsigned short num){
	char query[8192];
	int count;

	if(in[4])
		this->st.mJob = in[4];
	if(in[5])
		this->st.sJob = in[5];
	
	this->st.calcStats(this->l);

	this->h.hp = this->st.mHP;
	this->h.mp = this->st.mMP;
	this->h.hpp = 0x64;

	if(this->st.mMP == 0)
		this->h.mpp = 0x00;
	else
		this->h.mpp = 0x64;

	strcpy(query, "UPDATE charstats SET stat = '");
	count = strlen(query);
	count += mysql_real_escape_string(CDb::getConn(), query+count, (char *)&(this->st), sizeof(this->st));
	strcpy(query+count, "' WHERE charid = '");
	count += strlen(query+count);
	count += mysql_real_escape_string(CDb::getConn(), query+count, (char *)&(this->charid), sizeof(unsigned int));
	query[count++] = '\'';
	mysql_real_query(CDb::getConn(), query, count);

	return  this->st.charStats((unsigned char *)data, num, this->s);
}

int CChar::reqChar(unsigned char * data,  char * in, unsigned short num){
	int size = 0;
	unsigned short intarg;

	memcpy(&intarg, in+4, 2);
	
	unsigned short targ = this->currTarg;
	targ *=2;

	if(intarg == this->targid) {
		CConsole::outTime("Self");
		memset(data+size, 0, 96);
		data[size] = 0x0d;
		data[size+1] = 0x30;
		memcpy(data+size+2, &num, sizeof(num));
		memcpy(data+size+4, &(this->charid), 4);
		memcpy(data+size+8, &(this->targid), 2);
		data[size+0x0A] = 0x1f;
		data[size+0x0B] = (unsigned char)this->loc.p.rotation;
		memcpy(data+size+0x0C, &(this->loc.p.x), sizeof(float)*3);
		memcpy(data+size+0x1a, &targ, sizeof(targ));
		data[size+0x1C] = 0x28;
		data[size+0x1D] = 0x28;
		data[size+0x1F] = this->h.animation;
		int status = ((this->h.status & 0xff000000) >> 5) + ((this->h.status & 0x000000ff) << 7);
		memcpy(data+size+0x20, &(status), sizeof(int));
		memcpy(data+size+0x3E, &(this->l), sizeof(this->l));
		memcpy(data+size+0x40, &(this->l.head), 2);
		memcpy(data+size+0x42, &(this->l.body), 2);
		memcpy(data+size+0x44, &(this->l.hands), 2);
		memcpy(data+size+0x46, &(this->l.legs), 2);
		memcpy(data+size+0x48, &(this->l.feet), 2);
		memcpy(data+size+0x4A, &(this->l.main), 2);
		memcpy(data+size+0x4C, &(this->l.sub), 2);
		memcpy(data+size+0x4C, &(this->l.range), 2);
		memcpy(data+size+0x50, &(this->charname), 16);
		size += 96;
	}
	else {

		CNpc npc;
		for(unsigned int j = 0; j < CNpcHandler::npcZoneList[this->loc.zone].size(); j++) {
			npc = CNpcHandler::npcZoneList[this->loc.zone].at(j);
			if(npc.targid == intarg) {
				break;
			}

		}

		// Sorry for the redundancy...
		if(npc.targid == intarg) {
			//if(npc.type == 0x57 ){
			//	data[size+1] = (unsigned char)((0x33+strlen((const char*)npc.name)+20)/4)*2;
			//	memcpy(data+size+0x30, &(npc.lookc), 20);
			//	memcpy(data+size+0x30+20, npc.name, strlen((const char*)npc.name));
			//}
			if(npc.type == 0x57 ){
				memset(data,0,0x28*2);
 				memcpy(data+size+0x30, &(npc.lookc), 20);
				//memcpy(data+size+0x30+20, npc.name, strlen((const char*)npc.name));
				//data[size+1] = (unsigned char)((int)(0x33+strlen((const char*)npc.name)+20)/4)*2;
				data[size+1] = 0x28;
			}
			else if(npc.type == 0x07 ) {				
				memset(data,0,0x20*2);
				data[size+1] = 0x20;
				memcpy(data+size+0x30, &(npc.look), 4);
				memcpy(data+size+0x34, npc.name, 4);
			//	memcpy(data+size+0x38, &(npc.timestamp), 4);
			}
			else {
				memset(data,0,(unsigned char)((0x33+strlen((const char*)npc.name)+sizeof(int))/4)*2*2);
				data[size+1] = (unsigned char)((0x33+strlen((const char*)npc.name)+sizeof(int))/4)*2;
				memcpy(data+size+0x30, &(npc.look), 4);
			//	memcpy(data+size+0x34, npc.name, strlen((const char*)npc.name));
			}
			data[size] = 0x0E;
			memcpy(data+size+2, &num, sizeof(short));
			memcpy(data+size+4, &npc.id, 4);
			memcpy(data+size+8, &npc.targid, 2);
			data[size+0x19] = 0x80;
			data[size+0x1f] = npc.animation;
			data[size+10] = npc.type;

			data[size+0x1c] = npc.speed;
			data[size+0x1d] = npc.alt_speed;
			data[size+0x1E] = 0x64;
			data[size+0x27] = 0x20;
			data[size+0x20] = npc.status;
			data[size+0x2A] = npc.alt_animation;
			data[size+0x2B] = npc.namevis;
			memcpy(data+size+0x21,&npc.unknown, 3);

			data[size+11] = (unsigned char)npc.p.rotation;
			
			memcpy(data+size+12, &npc.p.x , 4);
			memcpy(data+size+16, &npc.p.y , 4);
			memcpy(data+size+20, &npc.p.z , 4);
			memcpy(data+size+24, &npc.flag, 4);

			//data[size+0x2a] = 0x01;
			
			size += data[size+1]*2;

			CConsole::outTime("------------------------");
			printf("\n ");
			for(int i = 0; i< size; i++) {
				printf("%x ", data[i]);
				if(((i+1)%16) == 0)
					printf("\n");
			}
		}
	}
	return size;
}

// is a char in the specefied zone?
bool CChar::isCharInZone(unsigned char zone) {
	CChar *currChar;
	for(currChar = CChar::first.next; currChar != 0; currChar = currChar->next){
		if(currChar->loc.zone == zone){
			return true;
		}
	}

	return false;
}

bool CChar::hasKeyItem(char keyItemId) {

	if(((int)this->k.keyList[keyItemId/8]) & (int)pow((double)2,(int)(keyItemId % 8))) {
		return true;
	}
	return false;
}

bool CChar::seenKeyItem(char keyItemId) {

	if(((int)this->k.seenList[keyItemId/8]) & (int)pow((double)2,(int)(keyItemId % 8))) {
		return true;
	}
	return false;
}

int CChar::addCommList(CComm comm) {
	while(this->commListLocked) {
	}
	this->commListLocked = true;
	this->commList.push_back(comm);
	this->commListLocked = false;
	return 0;
}

void CChar::calculateAttackSpeed() {
	MYSQL_RES * res;
	MYSQL_ROW row;
	char query[8192];
	int count;

	this->weapondelay = 0;
	count = sprintf(query, "(SELECT `Delay` FROM stats_weapons WHERE itemID = %i) ",this->e.ItemID[0]);
	count = strlen(query);
	mysql_real_query(CDb::getConn(), query, count);
	
	if(!(res = mysql_store_result(CDb::getConn()))){
		CConsole::outErr("Error looking up modelid");
	}
	if(mysql_num_rows(res)){
		row = mysql_fetch_row(res);
		this->weapondelay = atoi(row[0]);
		mysql_free_result(res);
	}
	return;
}