#include "../include/includes.h"

std::vector<CNpc> CNpcHandler::npcZoneList[256];
std::vector<CMob> CNpcHandler::mobZoneList[256];
std::vector<struct timer> CNpcHandler::npcTimerList[256];

CNpcHandler::CNpcHandler(void)
{
}

CNpcHandler::~CNpcHandler(void)
{
}

int CNpcHandler::loadZoneList(unsigned short zone){
	MYSQL_RES * res;
	MYSQL_ROW row;
	unsigned long size = 0, count, *lengths;
	char query[4096];
	

	if((CNpcHandler::npcZoneList[zone].size() > 0)){
		CNpcHandler::npcZoneList[zone].clear();
	}

	if((CNpcHandler::mobZoneList[zone].size() > 0)){
		CNpcHandler::mobZoneList[zone].clear();
	}
	
	if((CLuaManager::regionList[zone].size() > 0)){
		CLuaManager::regionList[zone].clear();
	}


	sprintf(query, "SELECT name, id, type, pos_rot, pos_x, pos_y, pos_z, flag, look, animation, alt_animation, namevis, speed, alt_speed, targid, status, unknown FROM `npc_%s` ORDER BY id ASC", CNpcHandler::getZoneName(zone));
	count = strlen(query);
	//count += mysql_real_escape_string(CDb::getConn(), query+count, (char *)&(zone), sizeof(char));
	//strcpy(query+count, "' ORDER BY id ASC");
	//count += 17;
	mysql_real_query(CDb::getConn(), query, count);
	if(!(res = mysql_store_result(CDb::getConn()))){
		CConsole::outErr("Zone 0x%X\t -> %s not found in DB!",zone ,CNpcHandler::getZoneName(zone));
		//return 0;
	}else if(!mysql_num_rows(res)){
		mysql_free_result(res);
		//return size;
	} else {
		int npccnt = 0;
		int mobcnt = 0;

		while((row = mysql_fetch_row(res))){
			lengths = mysql_fetch_lengths(res);
			CNpc npc;
			memset(npc.name, 0 , 50);
			memcpy(npc.name, row[0], lengths[0]);
			npc.id				= atoi(row[1]);
			npc.type			= atoi(row[2]);
			npc.p.rotation		= atoi(row[3]);
			npc.p.x				= (float)atof(row[4]);
			npc.p.y				= (float)atof(row[5]);
			npc.p.z				= (float)atof(row[6]);
			npc.flag			= atoi(row[7]);

			if(npc.type == 0x57){
				memcpy(&npc.lookc, row[8], 20);
			}
			else {
				memcpy(&npc.look, row[8], 4);
			}

			npc.animation		= atoi(row[9]);
			npc.alt_animation	= atoi(row[10]);
			npc.namevis			= atoi(row[11]);
			npc.speed			= atoi(row[12]);
			npc.alt_speed		= atoi(row[13]);
			npc.targid			= atoi(row[14]);
			npc.status			= atoi(row[15]);
			npc.unknown			= atoi(row[16]);

			npc.incombat = false;
			npc.ownerId  = 0;
			npc.oldtime  = 0;
			npc.update   = false; 
			npc.timestamp = 0;
			if((npc.status == 0x07) || (npc.status == 0x01)) {
				mobcnt++;
				CMob mob;
				
				memcpy(&mob,&npc, sizeof(CNpc));
				mob.status = 0x01;
				mob.hp = 300;
				mob.maxhp = 300;
				mob.mp = 50;

				CNpcHandler::mobZoneList[zone].push_back(mob);
			}
			else {
				npccnt++;
		//		CConsole::outTime("%x" ,npc.id);
				
				if((!stricmp(npc.name, "Moogle")) && ((npc.id == 0x10f606a) || (npc.id == 0x10eb05d))) {
					CNpcHandler::npcZoneList[0xd6].push_back(npc);
					CNpcHandler::npcZoneList[0xd7].push_back(npc);
					CNpcHandler::npcZoneList[0xd8].push_back(npc);
					CNpcHandler::npcZoneList[0xd9].push_back(npc);
					CNpcHandler::npcZoneList[0xda].push_back(npc);

					CNpcHandler::npcZoneList[0xfd].push_back(npc);
					CNpcHandler::npcZoneList[0xfe].push_back(npc);
					CNpcHandler::npcZoneList[0xff].push_back(npc);
				}

				CNpcHandler::npcZoneList[zone].push_back(npc);
			}
		}
		CConsole::outTime("Zone 0x%X\t -> %i NPCs %i MOBs loaded!",zone ,npccnt, mobcnt);
	}

	//LUA - Initialize zone
	char file[255];
	lua_State* state = NULL;
	state = lua_open();
	CLuaManager::Initialize(state);
	CLuaManager::addVars(zone,state);
	sprintf(file, "scripts/zones/%s/initializezone.lua", CNpcHandler::getZoneName(zone));
	if(CLuaManager::scriptExists(file)) {
		CLuaManager::runScript(file, state);
	}
	lua_close( state );

	return 0;
}

unsigned int couNT = 0;

int CNpcHandler::spawnNpcs(unsigned char * data, unsigned short num, CChar * schar){

	unsigned long size = 0;
	long double oldtime;
	unsigned int j;
	int wait = 0;
	unsigned int i;
	bool onList = false;
	unsigned int couNT2 = 0;

	if((CNpcHandler::npcTimerList[schar->loc.zone].size() > 0)) {
		for(unsigned int i = 0; i < CNpcHandler::npcTimerList[schar->loc.zone].size(); i++) {
			oldtime = (long double)CNpcHandler::npcTimerList[schar->loc.zone].at(i).timestamp;
			wait = CNpcHandler::npcTimerList[schar->loc.zone].at(i).timetowait;

			if((oldtime + (wait)) < (long double)(time(NULL))) {
				switch(CNpcHandler::npcTimerList[schar->loc.zone].at(i).type) {

					case 0x01: {//doorclose
						CComm * comm = new CComm;
						comm->setComType(0x0e89);
						comm->ptr = CNpcHandler::npcTimerList[schar->loc.zone].at(i).ptr;
						schar->insertComm(CHAR_INRANGE_SELF, *comm);
						CNpcHandler::npcTimerList[schar->loc.zone].erase(CNpcHandler::npcTimerList[schar->loc.zone].begin()+i,CNpcHandler::npcTimerList[schar->loc.zone].begin()+i+1);
						break;
					}
				}
			}
		}
	}
	
	if((CNpcHandler::npcZoneList[schar->loc.zone].size() < 1) ) {
		return 0;
	}

	//Reset couNT incase when zoning you go onto a map that has less mobs than what couNT was previously set to
	if (couNT > (CNpcHandler::npcZoneList[schar->loc.zone].size()))
		couNT = 0;

	for(i = couNT; couNT2 < 10;) {
		i = ((i + 1) % (CNpcHandler::npcZoneList[schar->loc.zone].size()));

		memset(data+size, 0, 0x50);
		CNpc npc = CNpcHandler::npcZoneList[schar->loc.zone].at(i);

		//Reset the onList variable incase the last npc was on the last
		onList = false;

		// If Npc or Mob already spawned, don't spawn again.
		for(j = 0; j < schar->spawnIDList.size(); j++) {
			if(npc.id == schar->spawnIDList.at(j)) {
				onList = true;
				break;
			}
		}

		//We only need to generate packets if they need to be spawned or if they need to be de-spawned, otherwise its a waste
		if(((!onList) && (CUtil::distance(schar->loc.p, npc.p) < 60 )) || ((onList) && (CUtil::distance(schar->loc.p, npc.p) > 60 ))) {
			data[size] = 0x0E;
			//if(npc.type == 0x57 ){
			//	data[size+1] = (unsigned char)((0x33+strlen((const char*)npc.name)+20)/4)*2;
			//	memcpy(data+size+0x30, &(npc.lookc), 20);
			//	memcpy(data+size+0x30+20, npc.name, strlen((const char*)npc.name));
			//}
			if(npc.type == 0x57 ){
 				memcpy(data+size+0x30, &(npc.lookc), 20);
				//memcpy(data+size+0x30+20, npc.name, strlen((const char*)npc.name));
				data[size+1] = 0x28;//(unsigned char)((int)(0x33+strlen((const char*)npc.name)+20)/4)*2;
			}
			else if(npc.type == 0x07 ) {				
				data[size+1] = 0x20;
				memcpy(data+size+0x30, &(npc.look), 4);
				memcpy(data+size+0x34, npc.name, 4);
				memcpy(data+size+0x38, &(npc.timestamp), 4);
			}
			else {
				data[size+1] = (unsigned char)((0x33+strlen((const char*)npc.name)+sizeof(int))/4)*2;
				memcpy(data+size+0x30, &(npc.look), 4);
				memcpy(data+size+0x34, npc.name, strlen((const char*)npc.name));
			}
			memcpy(data+size+2, &num, sizeof(short));
			memcpy(data+size+4, &npc.id, 4);
			memcpy(data+size+8, &npc.targid, 2);
			data[size+0x19] = 0x80;
			data[size+0x1f] = npc.animation;
			data[size+10] = npc.type;

			data[size+0x1c] = npc.speed;
			data[size+0x1d] = npc.alt_speed;

			data[size+0x1E] = 0x64;

			data[size+0x27] = 0x20;

			data[size+0x2A] = npc.alt_animation;
			data[size+0x2B] = npc.namevis;
			data[size+11] = (unsigned char)npc.p.rotation;
			
			memcpy(data+size+12, &CNpcHandler::npcZoneList[schar->loc.zone].at(i).p.x , 4);
			memcpy(data+size+16, &CNpcHandler::npcZoneList[schar->loc.zone].at(i).p.y , 4);
			memcpy(data+size+20, &CNpcHandler::npcZoneList[schar->loc.zone].at(i).p.z , 4);
			memcpy(data+size+24, &npc.flag, 4);
			//memcpy(data+size+0x18, &schar->movCount, 2);
			
			memcpy(data+size+0x2c, &npc.ownerId, 4);
			memcpy(data+size+0x20, &npc.status, 1);
			memcpy(data+size+0x21, &npc.unknown, 3);

			couNT2++;

			if(!onList) {
				size += data[size+1]*2;
				// Add the npc to the list of spawned npcs of a char
				schar->spawnIDList.push_back(npc.id);
			}
			else if(onList) {
				data[size+0x20] = 0x07;
				size += data[size+1]*2;
				//Remove the mob we've just despawned from the list
				schar->spawnIDList.erase(schar->spawnIDList.begin()+j);
			}
		}
		if(i == couNT || i == (couNT -1))
			break;
	}
	couNT = i;
	return size;
	
}

unsigned int acouNT = 0;

int CNpcHandler::spawnMobs(unsigned char * data, unsigned short num, CChar * schar){

	unsigned long size = 0;
	unsigned int j;
	unsigned int i;
	bool onList = false;
	unsigned int acouNT2 = 0;


	if((CNpcHandler::mobZoneList[schar->loc.zone].size() < 1)) {
		return 0;
	}

	//Reset acouNT incase when zoning you go onto a map that has less mobs than what acouNT was previously set to
	if (acouNT > (CNpcHandler::mobZoneList[schar->loc.zone].size()))
		acouNT = CNpcHandler::mobZoneList[schar->loc.zone].size()-1;

	for(i = acouNT; acouNT2 < 10;) {
		i = ((i + 1) % (CNpcHandler::mobZoneList[schar->loc.zone].size()-1));
		memset(data+size, 0, 0x48);
		CMob mob = CNpcHandler::mobZoneList[schar->loc.zone].at(i);
		CNpcHandler::mobZoneList[schar->loc.zone].at(i).status = 0x01;

		//test sounds aggro
		if((mob.update == false) && (CUtil::distance(schar->loc.p, mob.p) < 7 ) && (mob.animation != 0x03)  &&(mob.status != 0x06)&&(mob.status == 0x01) && (mob.animation != 0x02)&& (schar->h.animation != 0x05) && (schar->h.animation != 0x03)) {
			CNpcHandler::mobZoneList[schar->loc.zone].at(i).animation = 0x01;
			CNpcHandler::mobZoneList[schar->loc.zone].at(i).update = true;
			CNpcHandler::mobZoneList[schar->loc.zone].at(i).victim = schar;
			//CreateThread(0,0,BattleServ,&CNpcHandler::mobZoneList[schar->loc.zone].at(i),0,0);
		}

		//Reset onList incase the previous mob was onList
		onList = false;
		// If Npc or Mob already spawned, don't spawn again.
		for(j = 0; j < schar->spawnIDList.size(); j++) {
			if(mob.id == schar->spawnIDList.at(j)) {
				onList = true;
				break;
			}
		}

		//We only need to generate packets if they need to be spawned or if they need to be de-spawned, otherwise its a waste
		if(((!onList) && (CUtil::distance(schar->loc.p, mob.p) < 60 )) || ((onList) && (CUtil::distance(schar->loc.p, mob.p) > 60 ))) {
			data[size] = 0x0E;
			if(mob.type == 0x57 ){
				data[size+1] = (unsigned char)((0x33+strlen((const char*)mob.name)+20)/4)*2;
				memcpy(data+size+0x30, &(mob.lookc), 20);
				memcpy(data+size+0x30+20, mob.name, strlen((const char*)mob.name));
			}
			else if(mob.type == 0x07 ) {
				data[size+1] = 0x20;
				memcpy(data+size+0x30, &(mob.look), 4);
				memcpy(data+size+0x34, mob.name, 4);
			}
			else {
				data[size+1] = (unsigned char)((0x33+strlen((const char*)mob.name)+sizeof(int))/4)*2;
				memcpy(data+size+0x30, &(mob.look), 4);
				memcpy(data+size+0x34, mob.name, strlen((const char*)mob.name));
			}

			memcpy(data+size+2, &num, sizeof(short));
			memcpy(data+size+4, &mob.id, 4);
			memcpy(data+size+8, &mob.targid, 2);
			data[size+0x1f] = mob.animation;
			data[size+10] = mob.type;

			data[size+0x1c] = mob.speed;
			data[size+0x1d] = mob.alt_speed;

			data[size+0x1E] = (mob.hp / mob.maxhp) *100;
	
			data[size+0x27] = 0x20;
			data[size+0x2A] = mob.alt_animation;
			data[size+0x2B] = mob.namevis;
			data[size+11] = (unsigned char)mob.p.rotation;
			
			memcpy(data+size+12, &CNpcHandler::mobZoneList[schar->loc.zone].at(i).p.x , 4);
			memcpy(data+size+16, &CNpcHandler::mobZoneList[schar->loc.zone].at(i).p.y , 4);
			memcpy(data+size+20, &CNpcHandler::mobZoneList[schar->loc.zone].at(i).p.z , 4);
			memcpy(data+size+24, &mob.flag, 4);
			memcpy(data+size+0x18, &schar->movCount, 2);
			
			memcpy(data+size+0x2c, &mob.ownerId, 4);
			memcpy(data+size+0x20, &mob.status, 1);
			memcpy(data+size+0x21, &mob.unknown, 3);


			acouNT2++;

			if(!onList) {
				size += data[size+1]*2;
				// Add the npc to the list of spawned npcs of a char
				schar->spawnIDList.push_back(mob.id);
			}
			else if(onList) {
				int despawn = 0x07;
				memcpy(data+size+0x20, &despawn, 4);
				size += data[size+1]*2;
				//Remove the mob we've just despawned from the list
				schar->spawnIDList.erase(schar->spawnIDList.begin()+j);
			}
		}
		if(i == acouNT || (i == acouNT-1)) 
			break;
	}
	acouNT = i;
	return size;
	
}


CNpc * CNpcHandler::getNpc(int npcid, int zone) {

	if((CNpcHandler::npcZoneList[zone].size() < 1)) {
		return 0;
	}

	for(unsigned int i = 0; i < CNpcHandler::npcZoneList[zone].size() ; i++) {
		if(CNpcHandler::npcZoneList[zone].at(i).id == npcid) {
			return &(CNpcHandler::npcZoneList[zone].at(i));
		}
	}

	return 0;
}

CNpc * CNpcHandler::getNpcByTarg(int npctargid, int zone) {

	if((CNpcHandler::npcZoneList[zone].size() < 1)) {
		return 0;
	}

	for(unsigned int i = 0; i < CNpcHandler::npcZoneList[zone].size() ; i++) {
		if(CNpcHandler::npcZoneList[zone].at(i).targid == npctargid) {
			return &(CNpcHandler::npcZoneList[zone].at(i));
		}
	}
	return 0;
}

CMob * CNpcHandler::getMobByTarg(int mobtargid, int zone) {

	if((CNpcHandler::mobZoneList[zone].size() < 1)) {
		return 0;
	}

	for(unsigned int i = 0; i < CNpcHandler::mobZoneList[zone].size() ; i++) {
		if(CNpcHandler::mobZoneList[zone].at(i).targid == mobtargid) {
			return &(CNpcHandler::mobZoneList[zone].at(i));
		}
	}
	return 0;
}


const char * CNpcHandler::getZoneName(unsigned short zone) {

	const char *ZONE_NAMES[] = {
    "unknown",
    "Phanauet_Channel",
    "Carpenters_Landing",
    "Manaclipper",
    "Bibiki_Bay",
    "Uleguerand_Range",
    "Bearclaw_Pinnacle",
    "Attohwa_Chasm",
    "Boneyard_Gully",
    "PsoXja",
    "The_Shrouded_Maw",
    "Oldton_Movalpolos",
    "Newton_Movalpolos",
    "MineShaft_#2716",
    "Hall_of_Transference",
    "none",
    "Promyvion_Holla",
    "Spire_of_Holla",
    "Promyvion_Dem",
    "Spire_of_Dem",
    "Promyvion_Mea",
    "Spire_of_Mea",
    "Promyvion_Vahzl",
    "Spire_of_Vahzl",
    "Lufaise_Meadows",
    "Misareaux_Coast",
    "Tavnazian_Safehold",
    "Phomiuna_Aqueducts",
    "Sacrarium",
    "Riverne_Site_#B01",
    "Riverne_Site_#A01",
    "Monarch_Linn",
    "Sealions_Den",
    "AlTaieu",
    "Grand_Palace_of_HuXzoi",
    "The_Garden_of_RuHmet",
    "Empyreal_Paradox",
    "Temenos",
    "Apollyon",
    "Dynamis_Valkurm",
    "Dynamis_Buburimu",
    "Dynamis_Qufim",
    "Dynamis_Tavnazia",
    "Diorama_Abdhaljs_Ghelsba",
    "Abdhaljs_Isle_Purgonorgo",
    "none",
    "Open_sea_route_to_Al_Zahbi",
    "Open_sea_route_to_Mhaura",
    "Al_Zahbi",
    "none",
    "Aht_Urhgan_Whitegate",
    "Wajaom_Woodlands",
    "Bhaflau_Thickets",
    "Nashmau",
    "Arrapago_Reef",
    "Ilrusi_Atoll",
    "Periqia",
    "Talacca_Cove",
    "Silver_Sea_route_to_Nashmau",
    "Silver_Sea_route_to_Al_Zahbi",
    "The_Ashu_Talif",
    "Mount_Zhayolm",
    "Halvung",
    "Lebros_Cavern",
    "Navukgo_Execution_Chamber",
    "Mamook",
    "Mamool_Ja_Training_Grounds",
    "Jade_Sepulcher",
    "Aydeewa_Subterrane",
    "Leujaoam_Sanctum",
    "Chocobo_Circuit",
    "The_Colosseum",
    "Alzadaal_Undersea_Ruins",
    "Zhayolm_Remnants",
    "Arrapago_Remnants",
    "Bhaflau_Remnants",
    "Silver_Sea_Remnants",
    "Nyzul_Isle",
    "Hazhalm_Testing_Grounds",
    "Caedarva_Mire",
    "Southern_San_d'Oria_[S]",
    "East_Ronfaure_[S]",
    "Jugner_Forest_[S]",
    "Vunkerl_Inlet_[S]",
    "Batallia_Downs_[S]",
    "La_Vaule_[S]",
    "Everbloom_Hollow",
    "Bastok_Markets_[S]",
    "North_Gustaberg_[S]",
    "Grauberg_[S]",
    "Pashhow_Marshlands_[S]",
    "Rolanberry_Fields_[S]",
	"Beadeaux_[S]",
    "Ruhotz_Silvermines",
    "Windurst_Waters_[S]",
    "West_Sarutabaruta_[S]",
    "Fort_Karugo-Narugo_[S]",
    "Meriphataud_Mountains_[S]",
    "Sauromugue_Champaign_[S]",
    "Oztroja_Castle_[S]",
    "West_Ronfaure",
    "East_Ronfaure",
    "La_Theine_Plateau",
    "Valkurm_Dunes",
    "Jugner_Forest",
    "Batallia_Downs",
    "North_Gustaberg",
    "South_Gustaberg",
    "Konschtat_Highlands",
    "Pashhow",
    "Rolanberry_Fields",
    "Beaucedine_Glacier",
    "Xarcabard",
    "Cape_Teriggan",
    "Eastern_Altepa_Desert",
    "West_Sarutabaruta",
    "East_Sarutabaruta",
    "Tahrongi_Canyon",
    "Buburimu_Peninsula",
    "Meriphataud_Mountains",
    "Sauromugue_Champaign",
    "The_Sanctuary_of_ZiTah",
    "RoMaeve",
    "Yuhtunga_Jungle",
    "Yhoator_Jungle",
    "Western_Altepa_Desert",
    "Qufim_Island",
    "Behemoths_Dominion",
    "Valley_of_Sorrows",
    "Ghoyu's_Reverie",
    "RuAun_Gardens",
    "Mordion_Gaol",
    "unknown",
    "unknown",
    "Dynamis_Beaucedine",
    "Dynamis_Xarcabard",
    "Beaucedine_Glacier_[S]",
    "Xarcabard_[S]",
    "Castle_Zvahl_Baileys_[S]",
    "Horlais_Peak",
    "Ghelsba_Outpost",
    "Fort_Ghelsba",
    "Yughott_Grotto",
    "Palborough_Mines",
    "Waughroon_Shrine",
    "Giddeus",
    "Balgas_Dais",
    "Beadeaux",
    "Qulun_Dome",
    "Davoi",
    "Monastic_Cavern",
    "Castle_Oztroja",
    "Altar_Room",
    "The_Boyahda_Tree",
    "Dragons_Aery",
    "Castle_Zvahl_Keep_[S]",
    "Throne_Room_[S]",
    "Middle_Delkfutts_Tower",
    "Upper_Delkfutts_Tower",
    "Temple_of_Uggalepih",
    "Den_of_Rancor",
    "Castle_Zvahl_Baileys",
    "Castle_Zvahl_Keep",
    "Sacrificial_Chamber",
    "Garlaige_Citadel_[S]",
    "Throne_Room",
    "Ranguemont_Pass",
    "Bostaunieux_Oubliette",
    "Chamber_of_Oracles",
    "Toraimarai_Canal",
    "Full_Moon_Fountain",
    "Crawlers'_Nest_[S]",
    "Zeruhn_Mines",
    "Korroloka_Tunnel",
    "Kuftal_Tunnel",
    "The_Eldieme_Necropolis_[S]",
    "Sea_Serpent_Grotto",
    "VeLugannon_Palace",
    "The_Shrine_of_RuAvitau",
    "Stellar_Fulcrum",
    "LaLoff_Amphitheater",
    "The_Celestial_Nexus",
    "Walk_of_Echos",
    "The_Last_Stand",
    "Lower_Delkfutts_Tower",
    "Dynamis_San_dOria",
    "Dynamis_Bastok",
    "Dynamis_Windurst",
    "Dynamis_Jeuno",
    "unknown",
    "King_Ranperres_Tomb",
    "Dangruf_Wadi",
    "Inner_Horutoto_Ruins",
    "Ordelles_Caves",
    "Outer_Horutoto_Ruins",
    "The_Eldieme_Necropolis",
    "Gusgen_Mines",
    "Crawlers_Nest",
    "Maze_of_Shakhrami",
    "unknown",
    "Garlaige_Citadel",
    "Cloister_of_Gales",
    "Cloister_of_Storms",
    "Cloister_of_Frost",
    "FeiYin",
    "Ifrits_Cauldron",
    "QuBia_Arena",
    "Cloister_of_Flames",
    "Quicksand_Caves",
    "Cloister_of_Tremors",
    "unknown",
    "Cloister_of_Tides",
    "Gustav_Tunnel",
    "Labyrinth_of_Onzozo",
    "Al_Zahbi_Residential_Area",
    "Jeuno_Residential_Area",
    "San_dOria_Residential_Area",
    "Bastok_Residential_Area",
    "Windurst_Residential_Area",
    "unknown",
    "Ship_bound_for_Selbina",
    "Ship_bound_for_Mhaura",
    "unknown",
    "San_dOria_Jeuno_Airship",
    "Bastok_Jeuno_Airship",
    "Windurst_Jeuno_Airship",
    "Kazham_Jeuno_Airship",
    "Ship_bound_for_Selbina_Pirate",
    "Ship_bound_for_Mhaura_Pirate",
    "unknown",
    "Southern_San_dOria",
    "Northern_San_dOria",
    "Port_San_dOria",
    "Chateau_dOraguille",
    "Bastok_Mines",
    "Bastok_Markets",
    "Port_Bastok",
    "Bastok_Metalworks",
    "Windurst_Waters",
    "Windurst_Walls",
    "Port_Windurst",
    "Windurst_Woods",
    "Heavens_Tower",
    "RuLude_Gardens",
    "Upper_Jeuno",
    "Lower_Jeuno",
    "Port_Jeuno",
    "Rabao",
    "Selbina",
    "Mhaura",
    "Kazham",
    "Hall_of_the_Gods",
    "Norg",
    "San_dOria_Residential_Area",
    "Bastok_Residential_Area",
    "Windurst_Residential_Area",};

	return ZONE_NAMES[zone];

}

DWORD WINAPI ZoneServ(LPVOID lpParam) {
	unsigned char *zone = (unsigned char*)lpParam;
	char buffer[300];
	int m_cid;
	CComm comm;

	while(1) {
		if(CChar::isCharInZone(*zone)) {
			for(unsigned int i = 0; i < CNpcHandler::mobZoneList[*zone].size(); i++) {

				CMob * mob = &CNpcHandler::mobZoneList[*zone].at(i);

				if(mob->update) {

				

					if(((long long)clock() - mob->oldtime) > 500){
						CComm comm;
						comm.pData.c = buffer;
						memset(comm.message, 0, 200);
						mob->face( mob->victim->loc.p );

						if((CUtil::distance(mob->p, mob->victim->loc.p) > 3)){
							mob->moveTo(mob->victim->loc.p);
						}

						comm.charid = mob->updateMob((unsigned char*)comm.message, mob->victim);
						comm.setComType(0x1234);
						mob->victim->insertComm(CHAR_INZONE_SELF, comm);
						mob->oldtime = clock();

						if(mob->animation == 0x03) {
							mob->update = false;
							mob->victim = NULL;
						}
					}

					//Mob Attacking
						if( mob->hp <= 0) {
							mob->hp = 0;
							mob->animation = 0x03;
							mob->ownerId = 0x00;
							break;
						}
					//Mob doesn't have a target, it can't attack / do combat
					if(mob->victim == NULL) {
						break;
					}

					//Mobs target is dead, can't fight anything then..
					if(mob->victim->h.hp == 0) {
						mob->animation = 0x00;
						mob->ownerId = 0x00;
						mob->update = false;
						break;
					}
					memset(buffer,0,300);

					//Can the mob attack yet (3 second attack delay)
					if(((long long)clock() - mob->oldAttackTime) > 3000){
						
						//Build the attack packet
						buffer[0] = 0x28;
						buffer[1] = 0x24;

						memcpy(buffer+5,&mob->id,4);
						buffer[0x09] = 0x02; 
						buffer[0x0a] = 0x40 +0x04;
						buffer[0x0b] = 0x18;

						buffer[0x0c] = 0xdd;
						buffer[0x0d] = 0x1a;
						buffer[0x0e] = 0x0c;

						buffer[0x16] = 0x80;
						buffer[0x17] = 0x40*0x80;
						buffer[0x18] = 0x18*0x80;

						buffer[0x1a] = 0x08;
						buffer[0x1c] = 0x08;
						//0x00 	 1

						m_cid = mob->victim->charid * 0x40;

						memcpy(buffer+0x12,&m_cid,4);

						comm.charid = 0x24*2;
						memcpy(comm.message, buffer, 0x24*2);

						comm.setComType(0x1234);

						//Do the damage to the player
						mob->victim->h.hp -= 1;
						mob->victim->h.hpp = ((float)mob->victim->h.hp / (float)mob->victim->st.mHP) * 100;

						//Update the zone about the attack
						mob->victim->insertComm(CHAR_INZONE_SELF, comm);

						//See if our target is dead
						if( mob->victim->h.hp <= 0) {
							mob->victim->h.hp = 0;
							mob->animation = 0x00;
							mob->ownerId = 0x00;
							mob->update = false;
							break;
						}

						//Time the next attack
						mob->oldAttackTime = (long long) clock();
					}
				}
			}
		}
		Sleep(10);
	}
	return 0;
}

DWORD WINAPI BattleServ(LPVOID lpParam) {
/*	CMob *mob = (CMob*)lpParam;
	char buffer[300];
	//Char * schar;
	
	int m_cid;
	CComm comm;
	

	while(1) {

		Sleep(10);
	}*/
	return 0;
}

DWORD WINAPI CharBattleServ(LPVOID lpParam) {

	CChar * schar= (CChar*)lpParam;
	char buffer[300];
	//Char * schar;
	//CMob * mob = CNpcHandler::getMobByTarg(schar->currTarg, schar->loc.zone);
	CMob * target = CNpcHandler::getMobByTarg(schar->currTarg,schar->loc.zone);

	if (target == NULL)
		return 0;

	int m_cid;
	CComm comm;
	CComm comm2;
	CComm comm3;
	comm3.setComType(0x1234);
	comm3.charid = 0x08*2;
	comm3.message[0] = 0x58;
	comm3.message[1] = 0x08;
	memcpy(comm3.message+4,&schar->charid,4);
	memcpy(comm3.message+8,&target->id,4);
	memcpy(comm3.message+12,&schar->targid,2);
	memcpy(comm3.message+14,&target->targid,2);
	schar->addCommList(comm3);
	schar->calculateAttackSpeed();


	while(1) {
		if(target == NULL) return 0;
		memset(buffer,0,300);
		if(schar->currTarg == 0x00) {
			break;
		}

		if(schar->h.hp <= 0) {
			return 0;
		}
		
		// 2008/09/04 UԊuݒ Mod-Start
		//if((((long long)clock() - schar->oldAttackTime) > ((float)((schar->weapondelay+240)/60)*1000))){

		float delay;

		if(schar->atkdelay == 0) {
			// UԊuݒ肪l(0)̏ꍇ́AԊuUԊuƂ
			delay = (float)schar->weapondelay + 240;
		}
		else {
			delay = (float)schar->atkdelay;
		}

		if(((long long)clock() - schar->oldAttackTime) > ((delay / 60) * 1000)) {
		// 2008/09/04 UԊuݒ Mod-End
			if(!schar->inBattle) {
				return 0;
			}

			if((CUtil::distance(schar->loc.p,target->p) > 4)){
				CComm comm5;
				comm5.setComType(0x1234);
				memset(comm5.message,0,0x0e*2);
				comm5.message[0] = 0x29;
				comm5.message[1] = 0x0e;
				comm5.message[0x18] = 0x04;
				memcpy(comm5.message+4,&schar->charid,4);
				memcpy(comm5.message+8,&target->id,4);
				memcpy(comm5.message+0x14,&schar->targid,2);
				memcpy(comm5.message+0x16,&target->targid,2);
				comm5.charid = 0x0e*2;
				schar->addCommList(comm5);
				schar->oldAttackTime = (long long) clock();
				continue;
			}

			buffer[0] = 0x28;
			buffer[1] = 0x24;

			memcpy(buffer+5,&schar->charid,4);
			buffer[0x09] = 0x02; 
			buffer[0x0a] = 0x40 +0x04;
			buffer[0x0b] = 0x18;

			int n;
			char number[4];
	 
			srand((int)rand()*clock());

			n=30+(int)(rand()%100); 
			itoa(n, number, 10);

			buffer[0x0c] = 0xdd;
			buffer[0x0d] = 0x1a;
			buffer[0x0e] = 0x0c;

			buffer[0x16] = 0x80;
			buffer[0x17] = 0x40*0x80;
			buffer[0x18] = 0x18*0x80;
			target->hp -= n;
			n = n*0x08;
			memcpy(buffer+0x1a,&n,2);
		
			buffer[0x1c] = 0x08;
			//0x00 	 1

			m_cid = target->id * 0x40;

			memcpy(buffer+0x12,&m_cid,4);

			comm.charid = 0x24*2;
		
			
			memcpy(comm.message, buffer, 0x24*2);

			comm.setComType(0x1234);
			comm2.setComType(0x1234);
			
			if(target->ownerId == 0) {
				target->ownerId = schar->charid;
			}

			if( target->hp <= 0) {
			
				schar->h.animation = 0x00;
				comm2.charid = schar->updateChar((unsigned char*)comm2.message, 0x00 );
				schar->insertComm(CHAR_INZONE_SELF, comm2);

				CComm comm4;
				comm4.setComType(0x1234);
				memset(comm4.message,0,0x0e*2);
				comm4.message[0] = 0x29;
				comm4.message[1] = 0x0e;
				comm4.message[0x18] = 0x06;
				comm4.message[0x1a] = 0x01;
				memcpy(comm4.message+4,&schar->charid,4);
				memcpy(comm4.message+8,&target->id,4);
				memcpy(comm4.message+0x14,&schar->targid,2);
				memcpy(comm4.message+0x16,&target->targid,2);
				comm4.charid = 0x0e*2;
				schar->addCommList(comm4);
			}

			//target->animation = 0x03;
			//target->h.hpp = ((float)target->h.hp / (float)target->st.mHP) * 100;
			
			schar->insertComm(CHAR_INZONE_SELF, comm);
			
			schar->oldAttackTime = (long long) clock();
			
	
		}
		Sleep(10);
	}
	return 0;
}